/* D3D: ஥஢  嬥୮ ࠭⢥.
    - .ࠫ (ૠ).

    ᫥ 樨   (D3D)  
    ।஢ ᮢ⭮  ﬨ:
    GRPACK ( GRPACK1) (. ࠧ 4.3)
    HLPFUN  (. ࠧ 4.4) 
    TRAFO   (. ࠧ 3.7).
     ᯮ짮  Turbo C  Borland.
     : Huge.
     ਥ  ᪮ 몥  .. 좮.       */

/* D3D: Designing in Three Dimensions.
    After compilation, this module (D3D) is to be linked
    together with the modules
    GRPACK (or GRPACK1) (see Section 4.3),
    HLPFUN  (see Section 4.4), and
    TRAFO   (see Section 3.7).
    The compiler to be used is Turbo C of Borland.
    Memory model: Huge.                                    */

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <alloc.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include "grpack.h"
#include <dos.h>

#define BIG 1e10
#define IBIG 30000
#define EPS 1e-6
#define MAXFACES 2500

void
  initrotate(double a1, double a2, double a3,
	   double v1, double v2, double v3, double alpha),
  rotate(double x, double y, double z,
       double *px1, double *py1, double *pz1),
	       /* initrotate and rotate are defined in TRAFO */
       /* 㭪樨 'initrotate'  'rotate' ।  TRAFO */

  init_viewport(void),
  hlpfun(float rho, float theta, float phi, float surflimit),
  coeff(float rho, float theta, float phi),
  ermes(char *s);
    /* init_viewport, hlpfun and coeff are defined in HLPFUN     */
    /* 㭪樨 init_viewport, hlpfun  coeff ।  HLPFUN */

int abs(int x);

static void
  aspect(void),
  getstr(int X, int Y, char *str),
  mv(float x, float y, float z),
  dw(float x, float y, float z),
  screencoor(int mode, int i, int *pX, int *pY),
  viewing(float x, float y, float z,
			    double *pxe, double *pye, double *pze),
  display(void),
  plotpoint(int i, int Bold),
  grmes(int meslin, char *s),
  rdfile(int normal),
  wrfile(void),
  cursorcontrol(char direc),
  cursor(float x, float y, float z, int pos),
  show(char c),
  faces(void),
  eyepos(void),
  plotsph(float rho, float theta, float phi, int down),
  enquire(int vpos, char *str, float *px),
  textcursor(int col, int line),
  checkfaces(int i),
  infopage(int i),
  helpinfo(void),
  myungetch(char ch),
  line3(int P, int Q),
  checkall(void),
  clear(void),
  zoom(int large),
  reposition(void),
  plotaxes(int checksize),
  fresh(void),
  list_faces(void),
  points(void),
  transform(void),
  check_alloc(int i),
  asksave(void),
  entire(void),
  open_plotfile(void),
  close_plotfile(void),
  pressanykey(char *str);
static int
  storepoint(int i, float x, float y, float z),
  rdnumber(int *p),
  rdoldnr(int *p),
  getch1(void);
static char
  query(int line, char *s),
  mygetch(void);

struct linsegface    /* See module HLPFUN */ /* .  HLPFUN */
{int i; double a, b, c; struct linsegface *next;};
struct vertex
{ int inuse;
  float xw, yw, zw;
  double xe, ye, ze;
  struct linsegface *connect;
} *p;

float xO, yO, zO;

double v11, v12, v13, v21, v22, v23, v32, v33, v43,
  PI, PIdiv180;
float xmin, ymin, xmax, ymax;

static float c1, c2, d, c1first, c2first, dfirst,
  rho, theta, phi, xxx, yyy,
  Xvp_range, Yvp_range, Xvp_center, Yvp_center,
  Xvp_min, Xvp_max, Yvp_min, Yvp_max,
  xwmin, ywmin, zwmin, xwmax, ywmax, zwmax,
  xcur, ycur, zcur, step=0.2, zemin, zemax;

static int margin, modified, faces_present,
  zoomin, pridim, bufposition, inside, newcentralpoint,
  numbers=1, num0, axes, axes0, auxlines=1, aux0,
  bold=0, bold0, plength, psize, faces_entering,
  points_entering, X__max1, progr_arg,
  LIN1=190, LIN2=210, LIN3=230, LIN4=250,
  q[11]={22, 40, 54, 68, 82, 96, 110, 124, 138, 152, 166};
int nmax, **pface, nface, object_present;
static char buffer[50], s2[2], char_avail, filnam[40],
  spaces[60];

void main(int argc, char *argv[])

{ int i, lowest, highest;
  long lbytes;
  float threshold, surflimit, xlowest, xhighest;
  char str[30], ch, ch0, ch1;
  if (argc > 1)
  { strcpy(filnam, argv[1]); progr_arg = 1;
  }
  PI = 4 * atan(1.0);
  PIdiv180 = PI/180;
  pface = (int **)farcalloc(MAXFACES, sizeof(int *));
  psize = sizeof(struct vertex);
  lbytes = farcoreleft(); plength = lbytes/(3L * psize);
    /* About one third of free memory space is allocated for vertices */
    /*   ᢮  ⢥  設               */
  p = (struct vertex *)farcalloc(plength+7, psize);
  if (p == NULL)  /*  ermes("Memory problem") */
		      ermes("஡  ");
  s2[1] = '\0';
  margin = 456;
  rho = 1000; theta = 20; phi = 75;
  coeff(rho, theta, phi);
  clearscr();

  /*      D3D: Designing in Three Dimensions
	  ==================================
    This program is the main subject ofthe book:
    Ammeraal, L. (1988), INTERACTIVE 3D COMPUTER GRAPHICS,
    Chichester: John Wiley & Sons.
    Related books from the same author and publisher:
      PROGRAMMING PRINCIPLES IN COMPUTER GRAPHICS (1986),
      COMPUTER GRAPHICS FOR THE IBM PC  (1987),
      C FOR PROGRAMMERS (1986),
      PROGRAMS AND DATA STRUCTURES IN C (1987).
  */
  wrscr( 1,10, "                ணࠬ");
  wrscr( 3,10, "  '   '");
  wrscr( 5,10, "  ᠭ ⮩ ணࠬ ᮤন  ");
  wrscr( 7,10, "                . ࠫ");
  wrscr( 8,10, "  '   '");
  wrscr(10,10, "       ॢ  ᪮ 몠 ");
  wrscr(12, 7,
  "Ammeraal, L. (1988), INTERACTIVE 3D COMPUTER GRAPHICS,");
  wrscr(13, 16, "  Chichester: John Wiley & Sons.");
  wrscr(15, 32, "ॢ稪 좮 .., ., 1990.");
  if (progr_arg)
  { wrscr(18, 0,
      /* Do you want difference in line thicknesses? (Y/N): */
     "⥫쭠  ࠧ ⮫騭   㡨? (Y/N): ");
    settxtcursor(19, 0); ch = mygetch(); s2[0] = ch;
    if (isalpha(ch)) wrscr(19, 0, s2);
    bold = (ch == 'Y' || ch == 'y');
  }
  wrscr(21, 0, "    F1 ");
  wrscr(23, 0, " த   .... ");
  settxtcursor(23, 42);
  ch = mygetch();
  if (ch == 0 && getch() == 59 /* F1 */) helpinfo();
  initgr(); X__max1 = X__max+1;
  if (adaptype==1) {LIN1=132;LIN2=145;LIN3=155;LIN4=166;
		    for(i=0;i<11;i++) q[i]*=.72;	}
				/* ४   Y  CGA */
  for (i=(X__max1 - margin - 16)/8; i>=0; i--)
    spaces[i]=' ';   /* ப ஡ ;   ᨬ '\0'*/
		     /* String of spaces; '\0' at the end    */
  zoom(0);
     /* Set viewport constants; 0 = small viewport           */
     /* ⠭ ࠧ  뢮;  0 =   */

  clear(); display();
  if (progr_arg) rdfile(0);

		       /* Main loop: */     /*  横: */
  while
  (grmes(LIN1, /* "Command:" */  " a:"),
      textcursor(margin+140, LIN1),
      ch0=mygetch(), ch=toupper(ch0), ch != 'Q')
  { grmes(LIN2, " ");
    grmes(LIN3, " "); grmes(LIN4, " ");
    if (ch0==0)
    { ch1=mygetch();
      if (ch1 == 59)  /* Function key 1 */
                      /* 㭪樮쭠  F1 */
       helpinfo();
      continue;
    }
    show(ch);
    if (isdigit(ch))
    { if (points_entering) {myungetch(ch); points();} else
      if (faces_entering) {myungetch(ch); faces();} else
      grmes(LIN2,  /* "Don't begin with digit" */
		      " 稭 ன");
      continue;
    }

    if (ch == 'I')
    { points_entering = 1; points(); continue;
    }
    points_entering = 0;

    if (ch == 'F')
    { faces_entering = 1; faces(); modified = 1; continue;
    }
    faces_entering = 0;

    if (ch=='X' || ch=='Y' || ch=='Z')
    { cursorcontrol(ch); continue;
    }
    if (ch == 'R') rdfile(1); else
    if (ch == 'W') {wrfile(); modified = 0;} else
    if (ch == 'V') eyepos(); else
    if (ch == 'L') list_faces(); else
    if (ch == 'C')
    { *filnam='\0'; asksave(); clear(); display();
    } else
    if (ch == '?')
    { if (kbhit()) getch();
      grmes(LIN2,        /* "Point number: */   " 窨:");
      getstr(margin+104, LIN2, str);
      if (sscanf(str, "%d", &i) != 1 || i >= nmax ||
                                       p[i].inuse == 0)
      { grmes(LIN2,  /* "Number or format wrong" */
		     "᫮ (ଠ) "); continue;
      }
      sprintf(str, "%4.2f %4.2f %4.2f",
		    p[i].xw, p[i].yw, p[i].zw);
      grmes(LIN3, str);
    } else
    if (ch == 'D')
    { if (kbhit()) getch();
      while (nmax > 0 && p[nmax-1].inuse == 0) nmax--;
      xlowest = nmax;
      enquire(LIN2,  /* "Lower bound: " */
		     " ࠭: ", &xlowest);
      lowest = (int)(xlowest + 0.1);
      if (lowest < 1) lowest = 1;
      xhighest = xlowest;
      enquire(LIN3,  /* "Upper bound: " */
		     " ࠭: ", &xhighest);
      highest = (int)(xhighest + 0.1);
      if (highest >= nmax) highest = nmax - 1;
      if (lowest <= highest)
      { for (i=lowest; i<=highest; i++)
        { p[i].inuse = 0; checkfaces(i);
        }
        checkall(); modified = 1;
        display();
      }
    } else
    if (ch == 'M')
    { numbers =
      (query(LIN2, /* "Point numbers? */
		      " 祪? (Y/N):") == 'Y');
      axes0 = axes; aux0 = auxlines;
      axes = (query(LIN2, /* Axes? */
			      "? (Y/N): ") == 'Y');
      if (axes)
        auxlines =
	(query(LIN2,      /* Aux. lines? */
			  "ᯮ.? (Y/N): ") == 'Y');
      else auxlines = 0;
      bold = (query(LIN2,  /* Bold lines? */
			 " ? (Y/N):") == 'Y');
      if (axes0 && !axes || aux0 && !auxlines) checkall();
      /* Adapt image size now that axes have been removed and */
      /* more room may have become available for  the  image. */
      /* ४ ࠧ ࠦ, ᪮ ⥯   */
      /* 㤠   ࠦ 㯭  .     */
      if (query(LIN2,   /* Entire screen? */
			" ࠭? (Y/N):") == 'Y')
        entire(); else
      if (numbers != num0 || axes != axes0 ||
          auxlines != aux0 || bold != bold0) display();
    } else
    if (ch == 'E') entire(); else
    if (ch == 'P') printgr(0.0, X__max, 0.0, Y__max); else
    if (ch == 'S') enquire(LIN2, " 蠣:", &step); else
    if (ch == 'T') transform(); else
    if (ch == 'H')
    { clearpage();
      to_text();
      if (kbhit()) getch();
      wrscr(0, 0,
	 /* "Do you want the object faces to approximate  */
	 /*  curved surfaces? "                           */
      "㦭 , ⮡ ࠭ ꥪ பᨬ஢"
      "  孮? (Y/N): ");
      settxtcursor(0, 73);
      ch = mygetch(); s2[0]=ch;
      if (ch>32) wrscr(0, 73, s2);

      if (ch == 'Y' || ch == 'y')
      { wrscr(2, 0,
    " 'ண' 祭  ࠤ.   祭");
        wrscr(3, 0,
    " ᥤ ࠭,   ,  祭 ⮫쪮 ");
        wrscr(4, 0,
    "⮬ 砥, ᫨ 㣮  ࠬ ଠ    ࠭");
        wrscr(5, 0,
    "㤥  'ண' 祭.    㬮砭  ᯮ");
        wrscr(6, 0,
    "祭 35 ࠤᮢ, ᫨ 㤥  ⮫쪮  'Enter'.");
	settxtcursor(7, 15); ch = getchar();
	if (ch == '\n' ||
	(ungetc(ch, stdin), scanf("%f", &threshold) != 1))
           threshold = 35;
        surflimit = cos(threshold*PIdiv180);
      } else surflimit = 1.0;
      aspect();
      initgr();
      hlpfun(rho, theta, phi, surflimit);
      close_plotfile();
      ch = mygetch();
      if (ch == 'P' || ch == 'p')
        printgr(0, X__max, 0, Y__max);
      if (pridim)
      { clearpage(); to_text();
        x_max = 10.0; y_max = 7.0; pridim = 0;
        initgr();
      }
      display();
    } else grmes(LIN2, "ୠ ");  /* "Invalid command" */
  }
  asksave();
  to_text();
}

static void asksave(void)

{ char ch;
  if (modified && nmax + nface > 7)
  { ch = query(LIN2, "࠭ ? (Y/N):"); /* "Save object?" */
    if (ch == 'Y' || ch == 'y') wrfile();
    grmes(LIN2, " ");
  }
}

static void aspect()

{ char ch;
  wrscr(8, 0,
    "᫥ ⮡ࠦ १  ࠭      ");
  wrscr(9, 0,
    "筮 ਭ ⥬   P.");
  wrscr(10, 0,
    "᫨  ⮣  㤥      㣠  ,   ");
  wrscr(11, 0, "࠭ ⠭ ।饥 ࠦ.");
  wrscr(12, 0,
    "㤥  ,   ᯮ 筮 ⭮襭 ஭, ᫨");
  wrscr(13, 0,
    "㦭 ࠦ  㦭,   .");
  wrscr(14, 0,
    "ଠ쭮 ⭮襭 ஭ 㤥   ࠭.");
  wrscr(15, 0,
    "᫨    ୮ ⭮襭 ஭  㦭 ᯥ   ਭ");
  wrscr(16, 0,
    "( ᪠ ୮ ⭮襭  ࠭), ,  ,");
  wrscr(17, 0,
    "   A.       O ,  ᫨ 室");
  wrscr(18, 0,
    " 室 䠩  (xxx.PLT),    ⥬    ,");
  wrscr(19, 0,
    "ਬ, ⠭ ணࠬ PLOTHP  ନ஢  ࠦ-");
  wrscr(20, 0,
  "       㣮 䮯ந⥫.");
  wrscr(21, 0,
  "᫨ 祣 ⮣  㦭,     ...");

  settxtcursor(22, 0);
  ch = mygetch(); s2[0]=ch;
  if (ch > ' ') wrscr(22, 0, s2);
  if (ch == 'A' || ch == 'a')
  { setprdim(); pridim = 1;
  } else
  if (ch == 'O' || ch =='o') open_plotfile();
}

static void checkall(void)
		/* ⨥ ᫥ 㤠 窨, ᫨ 室 */
		/* Shrink, if required, after point deletion. */
{ int i, count=0;
  float xw, yw, zw, ze;
  xwmin = ywmin = zwmin = zemin = BIG;
  xwmax = ywmax = zwmax = zemax = -BIG;
  for (i=1; i<nmax; i++)
  if (p[i].inuse)
  { count++;
    xw = p[i].xw;
    yw = p[i].yw;
    zw = p[i].zw;
    ze = p[i].ze;
    if (xw < xwmin) xwmin = xw;
    if (xw > xwmax) xwmax = xw;
    if (yw < ywmin) ywmin = yw;
    if (yw > ywmax) ywmax = yw;
    if (zw < zwmin) zwmin = zw;
    if (zw > zwmax) zwmax = zw;
    if (ze < zemin) zemin = ze;
    if (ze > zemax) zemax = ze;
  }
  if (count == 0) clear(); else
  { if (xwmax < 0.5) xwmax = 0.5;
		/* To avoid axes of length 0		 */
		/* ⮡ ࠭ 砩 㫥  ᥩ */
    if (ywmax < 0.5) ywmax = 0.5;
    if (zwmax < 0.5) zwmax = 0.5;
    xO = BIG;
    /* 㦤 ᫨  業ࠫ ꥪ	*/
    /* Forces 'reposition' to compute new central object point	*/
    reposition();
  }
}

static void check_alloc(int i)

{ if (i >= plength) ermes  /* "Vertex number too high" */
			(" 設 ᫨誮 ");
}

static void checkfaces(int i)
  /* 窠 i ⮫쪮  뫠 㤠. ᫨ - ࠭ 砫
     設  ஬ i,   ࠭ ⠪ 㤠.		  */
  /* Point i has just been deleted. If any faces have i as
     a vertex, then these faces are deleted.			  */
{
  int j, n, k;
  if (nface == 0) return;
  grmes(LIN3,   /* Please wait ... */
		",  ...");
  for (j=0; j<nface; j++)
  { if (pface[j] == NULL) continue;
    n = pface[j][0];
    if (n<0) ermes("n<0  㭪樨 checkfaces");
    for (k=1; k<=n; k++)
    if (abs(pface[j][k]) == i)
    { farfree(pface[j]); pface[j] = NULL; break;
    }
  }
  grmes(LIN3, " "); grmes(LIN4, " ");
}

static void clear(void)

{ static int first=1;
  int i, j;
  axes = auxlines = numbers = 1;
  for (i=0; i<nmax; i++) p[i].inuse = 0;
  p[0].xw = p[0].yw = p[0].zw = 0.0;
  nmax = 1;
  for (j=0; j<nface; j++)
    if (pface[j] != NULL)
    { farfree(pface[j]); pface[j] = NULL;
    }
  nface = 0;
  xwmin = ywmin = zwmin = 0.0;
  xwmax = ywmax = zwmax = 1.0;
  xO = yO = zO = 0.5;
  fresh();
  reposition();
  if (first)
  { c1first = c1; c2first = c2; dfirst = d; first = 0;
  }
  modified = 0; object_present = 0;
}

static void close_plotfile(void)

{ if (fplot != NULL)
  { fclose(fplot);
    fplot = NULL;
  }
}

static void cursor(float xw, float yw, float zw, int pos)

{ extern int drawmode;
  int i, j, dm, cnt;
  static int X, Y, X0, Y0;
  if (pos)
  { inside = 1;
    for (cnt=0; cnt<2; cnt++)
    { storepoint(nmax+4, xw, yw, zw);
      storepoint(nmax+5, xw, yw, 0.0);
      screencoor(1, nmax+4, &X, &Y);
      screencoor(1, nmax+5, &X0, &Y0);
      if (inside) break; else
      { reposition(); display();
      }
    }
    if (cnt == 2) ermes("cnt = 2  㭪樨 cursor");
    p[nmax+4].inuse = 0;
    p[nmax+5].inuse = 0;
  }
  dm = drawmode; drawmode = 0;
  for (j=-2; j<=2; j+=4)
  for (i=-4; i<=4; i++) dot(X+i, Y+j);
  dot(X-4, Y-1); dot(X-3, Y-1);
  dot(X+3, Y-1); dot(X+4, Y-1);
  dot(X-4, Y); dot(X-3, Y); dot(X+3, Y);
  dot(X+4, Y);  dot(X, Y);
  dot(X-4, Y+1); dot(X-3, Y+1);
  dot(X+3, Y+1); dot(X+4, Y+1);
  draw_line(X, Y, X0, Y0);
  drawmode = dm;
}

static void cursorcontrol(char direc)

{ char c, c0, str[30];
  float *axis, x0, y0, z0, dx, dy, dz, dist2, d2;
  int i, j, jumped=0;
  if (!auxlines)
  { axes = auxlines = 1; display();
  }
  xcur = ycur = zcur = 0.0;
  cursor(xcur, ycur, zcur, 1);
  axis =
  (direc == 'X' ? &xcur : direc == 'Y' ? &ycur : &zcur);
  grmes(LIN2, ":" );
  grmes(LIN3, "   +, -, I, J,  D");
  grmes(LIN4, "(   Enter)");

  while (c0 = mygetch(), c = toupper(c0),
    c == '+' || c == '-' || c == 'X' || c == 'Y' || c == 'Z'

    || c == 'I' || c == 'J' || c == 'D' || c == 0)
  { if (c != 'D') jumped = 0;
    if (c == '+' || c == '-')
    { x0 = xcur; y0 = ycur; z0 = zcur;
      if (c == '-') *axis -= step; else *axis += step;
      cursor(x0, y0, z0, 0);
      cursor(xcur, ycur, zcur, 1);
      sprintf(str, "%5.2f %5.2f %5.2f   ",
                    xcur, ycur, zcur);
      grmes((LIN4+20), str);
      continue;
    }
    show(c);
    if (c == 'X') {axis = &xcur; direc = c;} else
    if (c == 'Y') {axis = &ycur; direc = c;} else
    if (c == 'Z') {axis = &zcur; direc = c;} else
    if (c == 'I')
    { for (i=1; i<plength; i++) if (p[i].inuse == 0) break;
      check_alloc(i);
      if (i >= nmax) nmax = i+1;
      cursor(xcur, ycur, zcur, 0); /* ࠭ */
      storepoint(i, xcur, ycur, zcur); modified = 1;
      plotpoint(i, 1);
      cursor(xcur, ycur, zcur, 0); /* 稢 ᭮ */
    } else                          /* Draw again */
    if (c == 'J')
    { if (nmax == 0)
      { grmes(LIN2, /* "No points present" */
			" 祪  稨");
        cursor(xcur, ycur, zcur, 0);
	grmes(LIN3, " "); grmes(LIN4, " ");  return;
      }
      dist2 = BIG;
      for (i=1; i<nmax; i++)
      if (p[i].inuse)
      { dx = p[i].xw - xcur;
        dy = p[i].yw - ycur;
	dz = p[i].zw - zcur;
	d2 = dx*dx + dy*dy + dz*dz;
        if (d2 < dist2) {dist2 = d2; j=i;}
      }
      jumped = 1;
      cursor(xcur, ycur, zcur, 0);  /* Delete old cursor */
				/* ࠭ ண  */
      xcur = p[j].xw; ycur = p[j].yw; zcur = p[j].zw;
      cursor(xcur, ycur, zcur, 1);
      sprintf(str, "%4d %4.2f %4.2f %4.2f",
                      j, xcur, ycur, zcur);
      grmes((LIN4+20), str);
    } else
    if (c == 'D')
    { if (!jumped) grmes(LIN4, /* "Use J first" */
				"砫  J"); else
      { p[j].inuse = 0; cursor(xcur, ycur, zcur, 0);
        checkfaces(j);
        checkall(); modified = 1; jumped = 0;
        display(); cursor(xcur, ycur, zcur, 1);
	grmes(LIN2,  ":");   /* "Press" */
	grmes(LIN3,  "+, -, I, J,  D");
	grmes(LIN4,  "(   Enter)"); /* "(or press Enter)" */
      }
    } else
	/* c == 0:  뫠    ५ */
	/* c == 0: Probably arrow key pressed */
    { if (getch() == 59) helpinfo(); else
      { grmes((LIN4+20), /* "Wrong key pressed" */
			"   ");
      }
    }
    show(direc);
  }
  cursor(xcur, ycur, zcur, 0);  /* Delete cursor */
				/* ࠭  */
  if (c0 != '\n' && c0 != '\r') myungetch(c0);
  show(' ');
  grmes(LIN2, " ");
  grmes(LIN3, " "); grmes(LIN4, " ");
			    grmes((LIN4+20), " ");
}

static void display(void)

{ int i, j, k, n, drawn, i_old;
  faces_present = 0;
  clearpage();
  if (axes) plotaxes(1);
  if (zoomin) init_viewport();
  /* Defined in module HLPFUN */   /* ।  㫥 HLPFUN */
  else
  { imove(0, 0); idraw(X__max, 0); idraw(X__max, Y__max);
    idraw(0, Y__max); idraw(0, 0);
    imove(margin-4, 0); idraw(margin-4, Y__max);
    textXY(margin, 5,   "ணࠬ D3D");
    textXY(margin, q[0],  "㯭  :");	    /* Available commands    */
    textXY(margin, q[1],  "X/Y/Z  ࠢ.஬");  /* Cursor control 	     */
    textXY(margin, q[2],  "?  祭 न");   /* Show coordinates      */
    textXY(margin, q[3],  "M-० (A-  ..)");  /* Mode (Axes etc.)      */
    textXY(margin, q[4],  "F1()| Q-室");	    /* (Help)    | Quit      */
    textXY(margin, q[5],  "S-蠣     | C-");  /* Step      | Clear     */
    textXY(margin, q[6],  "I-    | D-㤠");   /* Insert    | Delete    */
    textXY(margin, q[7],  "F-࠭   | L-ᯨ᮪");    /* Faces     | List      */
    textXY(margin, q[8],  "R-⥭  | W-");    /* Read      | Write     */
    textXY(margin, q[9],  "E- | H-");  /* Entire    | Hidden    */
    textXY(margin, q[10], "V-.७| T-८p.");   /* Viewpoint | Transform */
    grmes(LIN3, ",  ...");	    /* Please wait ...	*/
  }
  for (j=0; j<nface; j++)
  { if (pface[j] == NULL) continue;
    faces_present = 1;		 /* . 㭪 'list_faces' */
    i_old = abs(pface[j][1]);
    n = pface[j][0];
    if (n<0) ermes("n<0  㭪樨 display");
    for (k=2; k<=n; k++)
    { i = pface[j][k]; drawn = i >= 0; i = abs(i);
      if (drawn) line3(i_old, i);
      i_old = i;
    }
    i = pface[j][1]; drawn = i >= 0; i = abs(i);
    if (drawn) line3(i_old, i);
  }
  for (i=1; i<nmax; i++)
  if (p[i].inuse)
    plotpoint(i, 0);
  if (!zoomin)
  { grmes(LIN1, " :");        /* Command */
    grmes(LIN3, " "); grmes(LIN4, " ");
    num0 = numbers; axes0 = axes; aux0 = auxlines;
    bold0 = bold;
  }
  if (axes) plotaxes(0);
		/* Only to make letters x, y, z legible */
		/* 쪮 ⮡ ࠧ 祭 x, y, z */
}

static void dw(float x, float y, float z)

{ int X, Y;
  double xe, ye, ze;
  viewing(x-0.5, y-0.5, z-0.5, &xe, &ye, &ze);
			/* xO = yO = zO = 0.5 */
  X = IX(d*xe/ze+c1);
  Y = IY(d*ye/ze+c2);
  idraw(X, Y);
}

static void enquire(int vpos, char *str, float *px)

{ char snum[40], dum[40];
  int len, slen, j;
  char ch;
  if (kbhit()) getch();
  len = 8*strlen(str)+8;
  if (margin+len > X__max1)
    ermes   /* "String too long in 'enquire'" */
	  ("誮  ப  'enquire'");
  textXY(margin, vpos, str);
  sprintf(snum, "%3.1f", *px);
  slen = strlen(snum);
  if (snum[slen-1] == '0' && snum[slen-2] == '.')
    snum[slen-2] = '\0';
  if (margin+len+8*strlen(snum) > X__max1)
    ermes  /* "String plus number too long in 'enquire'" */
	    ("ப + ᫮ ᫨誮   'enquire'");
  slen = (X__max - margin - len)/8;
  for (j=0; j<slen; j++) dum[j] = ' ';
       textXY(margin+len-8, vpos, " ");
  dum[slen] = '\0';
  do
  { j = 100;
    do textXY(margin+len, vpos, dum);
      while (--j && !kbhit());
    j = 200;
    do textXY(margin+len, vpos, snum);
      while (--j && !kbhit());
  } while (!kbhit());
  ch = mygetch();
  if (ch == 0)
  { ch = mygetch();
    if (ch == 59)		/* key F1 */	/*  F1 */
    { helpinfo();
      textXY(margin+len, vpos, dum);
    } else
    if (ch == 3)		/* break */	/* 뢠 */
    { to_text(); exit(1);
    }
  } else
  if (ch == '\n' || ch == '\r') return; else myungetch(ch);
  while (1)
  { getstr(margin+len, vpos, snum);
    if (sscanf(snum, "%f", px) == 1) break;
    textXY(margin+len, vpos, dum);
  }
}

static void entire(void)	/* Use entire screen */
				/* ᯮ짮  ࠭ */

{ float c1save, c2save, dsave;
  char ch;
  c1save = c1; c2save = c2; dsave = d;
  clearpage();
  to_text();
  if (kbhit()) getch();
  aspect();	/* May cause x_max and y_max to be changed		 */
		/*  맢  祭 x_max  y_max	 */
  initgr();	/* Computes horfact and vertfact			 */
		/*  祭 樥⮢ horfact  vertfact */
  zoom(1);	/* Changes Xvp_max etc.					 */
		/*  ६ Xvp_max  ..			 */
  newcentralpoint = 0; /* May be changed in reposition			 */
		/*     㭪樨 'reposition'		 */
  reposition();	/* Compute new c1, c2, d                */
  		/* May also change central point        */
		/* ᫥  祭 c1, c2, d  */
		/*  ⠪  業ࠫ쭠 窠 */
  display();    /* Show large picture                   */
		/* 뢮 讣 ࠦ 		*/
  close_plotfile();
  ch = mygetch();
  if (ch == 'P' || ch == 'p') printgr(0, X__max, 0, Y__max);

  clearpage(); to_text();
  if (pridim)
  { x_max = 10.0; y_max = 7.0; pridim = 0;
  }
  initgr();
  zoom(0);
  if (newcentralpoint) reposition();
		/* Compute new c1, c2, and d		*/
		/* ᫥  祭 c1, c2, d  */
  else
  { c1 = c1save; c2 = c2save; d = dsave;
  }
  display();
}

void ermes(char *s)

{ char ch;
  if (in_textmode) {printf(s); exit(1);}
  /* 'in_textmode' -  ६ */ /* external variable */
  to_text();
  printf(s);
  if (!modified || nmax + nface <= 7) exit(1);
  printf  /* "D3D will stop execution." */
	("\n\n믮 ணࠬ D3D 稢.\n");
  printf /* "Do you want to save the object?" */
	(" ࠭ '? (Y/N): ");
  ch = getche();
  if (ch == 'Y' || ch == 'y')
  { initgr(); wrfile(); to_text();
  }
  exit(1);
}

static void eyepos(void)

{ float rho_1, theta_1, phi_1, rho1, theta1, phi1,
    dtheta, dphi, rho2;
  int i, n = 5;
  rho_1 = rho; theta_1 = theta; phi_1 = phi;
  rho = 1000; theta = 20; phi = 75;
  coeff(rho, theta, phi);
  clearpage();
  c1 = c1first; c2 = c2first; d = dfirst;
  mv(0.0, 0.0, 0.0); dw(1.0, 0.0, 0.0); text("x");
  mv(0.0, 0.0, 0.0); dw(0.0, 1.0, 0.0); text("y");
  mv(0.0, 0.0, 0.0); dw(0.0, 0.0, 1.0); text("z");
  mv(0.0, 0.0, 0.0);
  rho1 = 1.0; theta1 = 40; phi1 = 40;
  rho2 = rho1*sin(theta1*PIdiv180);
  plotsph(rho2, theta1, 90.0, 1);
  plotsph(rho1, theta1, phi1, 1);
  dw(0.0, 0.0, 0.0);
  rho1 = 0.9;
  dtheta = theta1/n;
  rho2 = 0.9 * rho2;
  mv(rho2, 0.0, 0.0);
  for (i=1; i<=n; i++) plotsph(rho2, i*dtheta, 90.0, 1);
  dphi = phi1/n;
  plotsph(rho1, 0.0, 0.0, 0);
  for (i=1; i<=n; i++) plotsph(rho1, theta1, i*dphi, 1);
  plotsph(0.5*rho1, theta1, phi1, 0); text("rho");
  plotsph(rho2, 0.4*theta1, 90.0, 0); text("theta");
  plotsph(rho1, theta1, 0.4*phi1, 0); text("phi");
  plotsph(1.2*rho1, theta1, phi1, 0); text("");
  textXY(margin, 15, " rho, theta, phi");
  textXY(margin, 30, "(theta, rho  ࠤ)");
  textXY(margin, 45, " ⨨   Enter ");
  textXY(margin, 60, "    ᯮ짮 ");
  textXY(margin, 75, "⮡ࠦ 祭.");
  enquire(90,  "rho   = ", &rho_1);
  enquire(105, "theta = ", &theta_1);
  enquire(120, "phi   = ", &phi_1);
  rho = rho_1; theta = theta_1; phi = phi_1;
  coeff(rho, theta, phi);
  xO = BIG;
    /* Forces 'reposition' to compute new central object point */
    /* 㦤 'reposition' ᫨  業ࠫ  */
  reposition(); display();
}

static void faces(void)

{ int i, n=0, draw, i_old=0;
  char str[30];
  double xA, yA, zA, xB, yB, zB, xC, yC, zC, a, b, c, h;
  if ((pface[nface] = (int *)farcalloc(5, sizeof(int)))
    == NULL)
    ermes(" 墠⠥ ");		  /* "Not enough memory" */
  grmes(LIN2, "ப ᥫ  窮:");  /* "Nrs. closed by period:" */
  textcursor(margin, LIN3);
  bufposition = -1;
  while (1)
  { if (rdnumber(&i) == 0) break;
    draw = i >= 0; i = abs(i);
    n++;
    if (p[i].inuse == 0)
    { sprintf(str, ". 窠: %6d", i);	/* "Undef. point: " */
      pressanykey(str); display();
      faces_entering = 0; return;
    }
    if (n == 1)
    { xA = p[i].xw; yA = p[i].yw; zA = p[i].zw;
    } else
    if (n == 2)
    { xB = p[i].xw; yB = p[i].yw; zB = p[i].zw;
    } else
    if (n == 3)
    { xC = p[i].xw; yC = p[i].yw; zC = p[i].zw;
      h = xA * (yB*zC - yC*zB) -
        xB * (yA*zC - yC*zA) +
        xC * (yA*zB - yB*zA);
      a = yA * (zB-zC) - yB * (zA-zC) + yC * (zA-zB);
      b = -(xA * (zB-zC) - xB * (zA-zC) + xC * (zA-zB));
      c = xA * (yB-yC) - xB * (yA-yC) + xC * (yA-yB);
    } else
    if (fabs(a*p[i].xw + b*p[i].yw + c*p[i].zw - h) >
                             0.001 * fabs(h) + EPS)
    { pressanykey("   ᪮");	/* "Not in the same plane" */
      display();				/* Remove any wrong lines */
					/*    ப  */
      faces_entering = 0; return;
    }
    if (n > 1 && draw) line3(i_old, i);
    i_old = i;
    if (n > 4)
    { if ((pface[nface] = (int *)farrealloc(
            pface[nface], (n+1) * sizeof(int))) == NULL)
      ermes(" 墠⠥ ");		/* "Not enough memory" */
    }
    pface[nface][n] = (draw ? i : -i);
  }
  if (n == 0)
  { grmes(LIN2, "୮ 楫 ᫮");	/* "Invalid integer" */
    farfree(pface[nface]); faces_entering = 0; return;
  }
  i = pface[nface][1];
  if (i >= 0)
  line3(i_old, i);
  pface[nface][0] = n; nface++;
  if (nface == MAXFACES)
  { grmes(LIN2, "誮  ࠭ "); nface--;   /* "Too many faces" */
  }
}

static void fresh(void)

{ int i, X, Y;
  xmin = ymin = zemin = BIG;
  xmax = ymax = zemax = -BIG; /* to be updated */   /*   */
	/* Compute xmin, xmax, ymin, ymax:  */
	/* ᫥ 祭 xmin, xmax, ymin, ymax: */
  storepoint(nmax, 0.0, 0.0, 0.0);
  storepoint(nmax+1, xwmax, 0.0, 0.0);
  storepoint(nmax+2, 0.0, ywmax, 0.0);
  storepoint(nmax+3, 0.0, 0.0, zwmax);
  screencoor(0, nmax, &X, &Y);
  screencoor(0, nmax+1, &X, &Y);
  screencoor(0, nmax+2, &X, &Y);
  screencoor(0, nmax+3, &X, &Y);
  for (i=nmax; i<nmax+4; i++) p[i].inuse = 0;
}

static int getch1(void)		/* Called only in 'rdnumber' */
				/* 뢠 ⮫쪮  'rdnumber' */
{ char ch;
  if (bufposition < 0)
  { getstr(margin, LIN3, buffer); bufposition = 0;
  }
  ch = buffer[bufposition++];
  if (8*bufposition >= X__max1 - margin)
  { getstr(margin, LIN3, buffer);
    ch = buffer[0]; bufposition = 1;
  } else
  if (ch == '\0')
  { bufposition = -1; ch = '\n';
  }
  return ch;
}

static void getstr(int X, int Y, char *str)

{ char ch;
  int i=0, first=1, j, k;
  while (1)
  { j=X+8*i;
    if (j >= X__max1-8) break;
    if (first)
    { for (k=X; k<X__max1-8; k+=8) textXY(k, Y, " ");
      first=0;
    }
    textcursor(j, Y);
    ch=mygetch();
    if (ch == '\n' || ch == '\r') break;
    if (ch==8)         /* backspace */   /* ࠭ ᨬ */
    { if (--i<0) i=0;
    } else
    { str[i] = s2[0] = ch;
      textXY(j, Y, s2);
      i++;
    }
  }
  str[i] = '\0';
}

static void grmes(int meslin, char *s)

{ int len;
  len = 8*strlen(s);
  if (!in_textmode)	/*  ६ */ /* external variable */
  { textXY(margin, meslin, spaces);
    if (margin+len > X__max1)
    { to_text(); printf(" 㭪樨 'grmes': \n");	/* "In grmes" */
      printf("s='%s' len=%d margin=%d", s, len, margin);
      exit(1);
    }
    textXY(margin, meslin, s);
  } else
  printf("%s\n", s);
}

static void helpinfo(void)

{ int i=1, was_in_grmode;
  was_in_grmode = !in_textmode;	/* external variable */
				/*  ६ */
  settxtcursor(24, 37);
  if (was_in_grmode)  { clearpage(); to_text();}
  do
  { infopage(i);
    if (i == 1)
    wrscr(24, 0,	/* "Press any key to continue ..." */
          "    த ...");
        else
    { wrscr(23, 0,
    "  '५ '    । ࠭");
      wrscr(24, 0,
     "     த ...");
    }
    if (mygetch() == 0 && mygetch() == 72)
    { if (--i == 0) i = 1;
    } else i++;
  } while (i < 4);
  if (was_in_grmode)
  { initgr(); display();
  }
}

static void infopage(int i)

{ if (i == 1)
  {
  clearscr();
  wrscr(0, 50, "࠭ 1 (ᥣ 3 ࠭)");
  wrscr(2, 0,  "D3D: ஥஢  嬥୮ ࠭⢥");
  wrscr(3, 0, " L. Ammeraal (ૠ)");
  wrscr(5, 0,
 "     ணࠬ D3D    ନ஢  ॠ  ࠦ");
  wrscr(6, 0,
 "嬥  '⮢.  ⥩訩  ᯮᮡ 砥  ᯮ짮");
  wrscr(7, 0,
 "䠩,  ⮢  ணࠬ   㣨  ᯮᮡ.");
  wrscr(8, 0,
 "஬  ⮣     室 䠩  । 窨 -");
  wrscr(9, 0,
 "⥫쭮,  ᯮ   I,   ।⢥   -");
  wrscr(10, 0,
 "  .   ࢮ 砥 ᫥  I 㦭  -");
  wrscr(11, 0,
 "⥫쭮 楫 ᫮  ⥬  嬥  न  x,  y,  z  ");
  wrscr(12, 0,
 "窨.    ஬  砥   । 樨 窨 ਬ");
  wrscr(13, 0,
 ".   ⮣ ᫥      X, Y, Z, ⥬ ");
  wrscr(14, 0,
 "+    -  ६饭 .   ࠢ   I");
  wrscr(15, 0,
 "  ,    J 뢠 室   ");
  wrscr(16, 0,
 " .   S   蠣 ६饭 -");
  wrscr(17, 0,
 ".   ⮡ࠦ 祭 न 窨 㦭    ");
  wrscr(18, 0,
 "।騬  ⥫   (?).   D  㤠");
  wrscr(19, 0,
 " 窨  ࠬ   .  ०   D");
  wrscr(20, 0,
 "㤠 ⮫쪮  ,  ࠭   J.   M ");
  wrscr(21, 0,
 "० 뢮 ஢ 祪, ᥩ,  ஥஢, ࠢ ⮫-");
  wrscr(22, 0,
 "騭   ࠧ஬ ࠭.                                       ");
 } else
  if (i == 2)
  {
  clearscr();
  wrscr(0, 50, "࠭ 2 (ᥣ 3 ࠭)");
  wrscr(1, 0,
 "     ᫥  ᪮쪨 祪      F  ।-");
  wrscr(2, 0,
 "  ࠭    १  ,  㪠 ᯨ᮪ ஢");
  wrscr(3, 0,
 "祪,  稢  ᨬ 窨 (.).  ਬ:                  ");
  wrscr(4, 0,"       F");
  wrscr(5, 0,"       1 2 3 4 5.");
  wrscr(6, 0,
 "     ᫨ ᫥  F  ,  祬  窨,   -");
  wrscr(7, 0,
 "砥,    設       ");
  wrscr(8, 0,
 " ᪮ ( .  ⠪  R ).  ᫥  H (. )");
  wrscr(9, 0,
 "   믮 ஫ ࠭ 嬥୮ '. 設");
  wrscr(10, 0,
 "    浪 室 ⨢ ᮢ ५ (  -");
  wrscr(11, 0,
 "  ' ). 訡   F   ᪮४஢-");
  wrscr(12, 0,
 "        L.    R 믮 뢠 ᠭ");
  wrscr(13, 0,
 "'  䠩,     W ' 뢠  䠩. -");
  wrscr(14, 0,
 "    窨  ७ 믮  V.  ⮬᪮");
  wrscr(15, 0,
 "㤠   ந室    H.   ");
  wrscr(16, 0,
 "訢  'ண' 祭  0  ᥤ ࠭ ( ");
  wrscr(17, 0,
 "७ 㣫   180 ࠤᠬ)  பᨬ஢  -");
  wrscr(18, 0,
 " 孮.  祭  ᥤ ࠭ 稢");
  wrscr(19, 0,
 "⮫쪮  ⮬ 砥,  ᫨ 㣮     ࠬ  ଠ  㤥");
  wrscr(20, 0,
 " 'ண' 祭.   E  뢮 ࠦ -");
  wrscr(21, 0,
 "  ࠭.   E  H  뢮  ࠦ");
  wrscr(22, 0,
 "  ਭ   .                                   ");
  }
  else
  if (i == 3)
  {
  clearscr();
  wrscr(0, 50, "࠭ 3 (ᥣ 3 ࠭)");
  wrscr(1, 0,
 "        䠩   EXAMPLE1.DAT  ..,  -");
  wrscr(2, 0,
 "뢠  '' 䠩', 뢠   W  -");
  wrscr(3, 0,
 "뢠   R. 砫  न  祪  ଠ");
  wrscr(4, 0,
 "'n x y z',   n -  窨.   ᫥ 祢 ᫮");
  wrscr(5, 0,
 "'Faces:' (࠭),  ᫥ 祣  ᯨ᮪ ᫥⥫쭮⥩ ஢");
  wrscr(6, 0,
 "祪  (.  ⠪  F).   ᫥⥫쭮 蠥");
  wrscr(7, 0,
 "窮 (.)  ᨬ #. 窨   ᫥⥫쭮 ");
  wrscr(8, 0,
 "設 ,  믮 ஫ ࠭ ' ᫥  -");
  wrscr(9, 0,
 " H.  ஭ ⠪  稢   ,  ");
  wrscr(10, 0,
 "᪫祭 ⥫ ஢ 祪.  ਬ,  '8 3 -5 2 7.'");
  wrscr(11, 0,
 "஭ 3 5  㤥 祭   . ᫥⥫쭮");
  wrscr(12, 0,
 "⮫쪮    祪 砥 ⤥ १ אַ .  -");
  wrscr(13, 0,
 " T ।   ८ࠧ,  : , -");
  wrscr(14, 0,
 "७, ⠡஢  ࠦ.  砫 ४ ᯮ-");
  wrscr(15, 0,
 "    R     ⥭   饣   䠩,   ਬ,");
  wrscr(16, 0,
 "EXAMPLE1.DAT;  ⥬ ஡   V   窨");
  wrscr(17, 0,
 "   E  뢮 ࠦ   ࠭. ");
  wrscr(18, 0,
 "४  ਬ  H  㤠  . ᫨");
  wrscr(19, 0,
 "᫥ ⮣     ⨭ ᠬ⥫쭮,");
  wrscr(20, 0,
 " ।⥫쭮 㦭  ࠭    C.          ");
 }
}

static void line3(int P, int Q)

{ float ze1, ze2, zrange=zemax-zemin+1e-15;
  int X1, Y1, X2, Y2, i1, i2, j1, j2;
  char str[10];
  static int dx[]={0, 1, -1, 0, 0},
             dy[]={0, 0, 0, 1, -1},
             n[]={5, 4, 3, 2, 1};
  screencoor(1, P, &X1, &Y1);		/* Computes xxx and yyy */
					/*  祭 xxx  yyy */
  if (zoom && fplot != NULL) move(xxx, yyy);
  screencoor(1, Q, &X2, &Y2);
  if (zoom && fplot != NULL) draw(xxx, yyy);
  if (!zoom || bold)
  { ze1 = p[P].ze; ze2 = p[Q].ze;
    i1 = (int)((ze1-zemin)/zrange * 4.999);
    i2 = (int)((ze2-zemin)/zrange * 4.999);
    if (i1<0 || i2<0 || i1>4 || i2>4)
    { to_text(); printf("i1=%d i2=%d\n", i1, i2);
      printf("P = %d\n", P);
      printf("Q = %d\n", Q);
      printf("ze1=%f ze2=%f zemin=%f zrange=%f\n",
              ze1, ze2, zemin, zrange);
      exit(1);
    }
    for (j1=0; j1<n[i1]; j1++)
    for (j2=0; j2<n[i2]; j2++)
    draw_line(X1+dx[j1], Y1+dy[j1], X2+dx[j2], Y2+dy[j2]);
  } else draw_line(X1, Y1, X2, Y2);
  if (numbers)
  { sprintf(str, "%d", P); imove(X1-2, Y1-5); text(str);
    sprintf(str, "%d", Q); imove(X2-2, Y2-5); text(str);
  }
}

static void list_faces(void)

{ int j, i, nch, nch0, count=0, n, nchmax;
  char str[50], ch;
  nchmax = (X__max-margin)/8;
  for (j=0; j<nface; j++)
  { if (pface[j] == NULL) continue;
    count++;
    n = pface[j][0]; nch = 0;
    if (n<0) ermes("n<0  ᯨc ࠭ list_faces");
    for (i=1; i<=n; i++)
    { nch0=nch;
      nch += sprintf(str+nch, " %d", pface[j][i]);
      if (nch > nchmax) { str[nch0] = '\0'; break; }
    }
    s2[0] = '.';
    grmes(LIN2, str);
    textXY(margin + 8*strlen(str), LIN2, s2);
    ch = query(LIN3, "OK? (Y/N): ");
    if (ch == 'N')
    { farfree(pface[j]); pface[j] = NULL; display();
      if (!faces_present &&
         (! axes || !auxlines || !numbers))
      { axes = auxlines = numbers = 1; display();
      }
    } else
    if (ch != 'Y') break;
  }
  if (count == 0) grmes(LIN2, " ࠭");       /* "No faces" */
	     else grmes(LIN2, " ");
  grmes(LIN3, " "); grmes(LIN4, " ");
}

int matherr(struct exception *a)

{ if (a->type == DOMAIN)
  { if (strcmp(a->name, "sqrt") == 0)
     ermes("訡  ᫥ sqrt domain");  /* "sqrt domain error" */
  }
  ermes("訡 ᫥  饩 窮");  /* "Floating point error" */
  return(0);	/* ᫥ ४饭 - 訡 */
		/* will not be executed due to ermes */
}

static void mv(float x, float y, float z)

{ int X, Y;
  double xe, ye, ze;
  viewing(x-0.5, y-0.5, z-0.5, &xe, &ye, &ze);
  /* xO = yO = zO = 0.5 */
  X = IX(d*xe/ze+c1);
  Y = IY(d*ye/ze+c2);
  imove(X, Y);
}

static char mygetch(void)

{ char ch;
  ch = getch();
  if (ch == 3)   /* Ctrl-C  or Ctrl-Break */
  { if (!in_textmode) to_text();
    exit(1);
  }
  char_avail = 0;
  return ch;
}

static void myungetch(char ch)

{ ungetch(ch); char_avail = 1;
}

static void open_plotfile(void)

{ char *p, *q, plfilnam[40];
  if (*filnam)
  { p=filnam; q=plfilnam;
    while (*p && *p != '.') *q++ = *p++;
    strcpy(q, ".plt");
  } else strcpy(plfilnam, "noname.plt");
  fplot = fopen(plfilnam, "w");
  if (fplot == NULL) ermes("  䠩 祭");
				/* "Can't open plotfile" */
}

static void plotaxes(int checksize)

{ int X0, Y0, X1, Y1, X2, Y2, X3, Y3, cnt, i;
  if (checksize)
  { storepoint(nmax, 0.0, 0.0, 0.0);
    storepoint(nmax+1, xwmax, 0.0, 0.0);
    storepoint(nmax+2, 0.0, ywmax, 0.0);
    storepoint(nmax+3, 0.0, 0.0, zwmax);
    screencoor(0, nmax, &X0, &Y0);
    screencoor(0, nmax+1, &X1, &Y1);
    screencoor(0, nmax+2, &X2, &Y2);
    screencoor(0, nmax+3, &X3, &Y3);
    reposition();
    inside = 1;
  }
  storepoint(nmax, 0.0, 0.0, 0.0);
  storepoint(nmax+1, xwmax, 0.0, 0.0);
  storepoint(nmax+2, 0.0, ywmax, 0.0);
  storepoint(nmax+3, 0.0, 0.0, zwmax);
  screencoor(1, nmax, &X0, &Y0);
  screencoor(1, nmax+1, &X1, &Y1);
  screencoor(1, nmax+2, &X2, &Y2);
  screencoor(1, nmax+3, &X3, &Y3);
  for (i=nmax; i<nmax+4; i++) p[i].inuse = 0;
  if (checksize && !inside)
  { to_text();
    printf ("室  । ( 㭪樨 plotaxes)\n");
    printf("d=%f c1=%f c2=%f\n", d, c1, c2);
    printf("Xvp_min=%f Xvp_max=%f  Yvp_min=%f Yvp_max=%f\n",
            Xvp_min, Xvp_max, Yvp_min, Yvp_max);
    for (cnt=nmax; cnt<nmax+4; cnt++)
    { printf("cnt=%d xe=%f ye=%f ze=%f X=%d Y=%d\n",
              cnt, p[cnt].xe, p[cnt].ye, p[cnt].ze,
              IX(d*p[cnt].xe/p[cnt].ze+c1),
              IY(d*p[cnt].ye/p[cnt].ze+c2));
    }
    exit(0);
  }
  imove(X0, Y0); idraw(X1, Y1); text("x");
  imove(X0, Y0); idraw(X2, Y2); text("y");
  imove(X0, Y0); idraw(X3, Y3); text("z");
}

static void plotpoint(int i, int Bold)

{ char str[30];
  int X, Y, Xxy0, Yxy0, cnt;
  inside = 1;
  for (cnt=0; cnt<2; cnt++)
  { screencoor(1, i, &X, &Y);
    if (auxlines)
    { storepoint(nmax+6, p[i].xw, p[i].yw, 0.0);
      screencoor(1, nmax+6, &Xxy0, &Yxy0);
      p[nmax+6].inuse = 0;
    }
    if (inside) break; else
    { reposition(); display();
    }
  }
  if (cnt == 2) ermes("cnt = 2  plotpoint");
  if (auxlines) draw_line(Xxy0, Yxy0, X, Y);
  dot(X, Y);
  if (numbers)
  { sprintf(str, "%d", i); imove(X-2, Y-5); text(str);
  } else
  if (nface == 0 || Bold)
  { dot(X-1, Y-1); dot(X, Y-1); dot(X+1, Y-1);
    dot(X-1, Y);                dot(X+1, Y);
    dot(X-1, Y+1); dot(X, Y+1); dot(X+1, Y+1);
  }
}

static void plotsph(float rho, float theta, float phi, int down)

{ float x, y, z, rcosphi, rsinphi, costh, sinth;
  theta = theta * PIdiv180; phi = phi * PIdiv180;
  rcosphi = rho * cos(phi); rsinphi = rho * sin(phi);
  costh = cos(theta); sinth = sin(theta);
  x = rsinphi * costh; y = rsinphi * sinth; z = rcosphi;
  if (down) dw(x, y, z); else mv(x, y, z);
}

static void points(void)

{ char str[50];
  int i;
  float x, y, z;
  grmes(LIN2, "n  x  y  z:");
  getstr (margin, LIN3, str);
  if (sscanf(str, "%d %f %f %f", &i, &x, &y, &z) != 4 || i <= 0)
  { grmes(LIN2, " ଠ ᫠");
    points_entering = 0;
    return;
  }
  check_alloc(i);
  if (i >= nmax) nmax = i+1;
  if (storepoint(i, x, y, z)) {checkall(); display();}
  plotpoint(i, 1); modified = 1;
}

static void pressanykey(char *str)

{ grmes(LIN2, str);
  grmes(LIN3, "  ...");	/* "Press any key ..." */
  mygetch();
}

static char query(int line, char *s)

{ int pos;
  char ch;
  grmes(line, s);
  pos = margin + 8 * strlen(s);
  textcursor(pos, line); ch = mygetch();
  s2[0] = ch; ch = toupper(ch);
  textXY(pos, line, s2);
  return ch;
}

static void rdfile(int normal)

{ FILE *fp;
  int ch, i_old=0, base, lowlimit,
     i, n, drawn, X, Y;
  float x, y, z, i_float;
  char str[40];
  modified = 0; 	/* File and data structure identical! */
			/*     ! */
  if (normal)
  { if (object_present)
    { ch = query(LIN2, " ࠭?(Y/N) ");   /* "Clear screen?" */
      if (ch == 'Y' || ch == 'y') clear();
      else modified = 1;
    }
    if (kbhit()) getch();
    grmes(LIN2, "室 䠩: ");		   /* "Input file: " */
    getstr(margin, LIN3, filnam);
  }
  fp = fopen(filnam, "r");
  if (fp == NULL) {grmes(LIN2, /* "Can't open file" */
				"  䠩"); return;}
  grmes(LIN4, ",  ...");	/* "Please wait ..." */
  grmes(LIN1, " ");

  base = nmax - 1; inside = 1; lowlimit = 32767;
  while
  (fscanf(fp, "%f %f %f %f", &i_float, &x, &y, &z) == 4)
  { if (getc(fp) != '\n')
    { grmes(LIN2, " ଠ 䠩.");	/* "Wrong file format." */
      grmes(LIN3, " n x y z");		/* "Use: n x y z" */
      fclose(fp); return;
    }
    i = (int)(i_float + 0.001);
    if (i <= 0)
    { grmes(LIN3, "  ⥫");  /* "Point nr. not positive" */
      fclose(fp); return;
    }
    i += base;
    if (i < lowlimit) lowlimit = i;
    check_alloc(i);
    if (i >= nmax) nmax = i+1;
    storepoint(i, x, y, z);
    screencoor(0, i, &X, &Y);
  }
  if (base && lowlimit < 32767)
  { grmes(LIN1, "  祪:");	/* "Range of new points:" */
    sprintf(str, "%d-%d", lowlimit, nmax - 1);
    pressanykey(str);
  }
  inside = 1;
  for (i=base; i<nmax; i++)
    if (p[i].inuse) screencoor(1, i, &X, &Y);

  if (!inside) reposition();
  do ch = getc(fp); while (isspace(ch));
  axes = numbers = (ch != 'F' && ch != 'f');
  if (!axes) auxlines = 0;
  display();
  if (!axes)		/* That is, if there are faces */
			/*    稨 ࠭ */
  { do ch = getc(fp); while (ch != '\n' && ch != EOF);
		/* Skip input line with keyword "Faces" */
		/* ய 室 ப  祢 ᫮ 'Faces' */
    while (fscanf(fp, "%d", &i) == 1)
    { if ((pface[nface] = (int *)farcalloc(5, sizeof(int)))
        == NULL)
	ermes(" 墠⠥ ");	/* "Not enough memory" */
      n = 0;
      while (1)
      { if (n > 0) {if (fscanf(fp, "%d", &i) <= 0) break;}
        n++;
        drawn = i >= 0; i = abs(i) + base;
        if (p[i].inuse == 0)
	{ sprintf(str, ". 窠: %6d", i);	/* "Undef. point: */
	  grmes(LIN3, str); fclose(fp); return;
        }
        if (n > 1 && drawn) line3(i_old, i);
        i_old = i;
        if (n > 4)
        { if ((pface[nface] = (int *)
          farrealloc(pface[nface], (n+1) * sizeof(int)))
          == NULL)
	  ermes(" 墠⠥ ");	 /* "Not enough memory" */
        }
        pface[nface][n] = (drawn ? i : -i);
      }
      ch = getc(fp);
      if (ch != '#' && ch != '.')
      { grmes(LIN3, /* "Period or # expected" */
			" 窠  #"); fclose(fp);
        return;
      }
      if (n > 2)
      { i = pface[nface][1];
        if (i >= 0) line3(i_old, i);
      }
      pface[nface][0] = n; nface++;
      if (nface == MAXFACES)
		ermes("誮  ࠭");	/* "Too many faces" */
    }
    ch = getc(fp);
  } else numbers = 1;
  if (ch != EOF) grmes(LIN2,  /* "Incorrect file format" */
				" ଠ 䠩");
  else grmes(LIN2, " ");
  grmes(LIN3, " ");  grmes(LIN4, " ");
  fclose(fp);
}

static int rdnumber(int *p)
		/* Called only in 'faces' and in 'transform' */
       /* 뢠 ⮫쪮  㭪権 'faces'  'transform' */

{ int i, neg, d, i0;
  char ch;
  *p = 0;
  do ch = getch1(); while (isspace(ch));
  neg = ch == '-';
  if (neg || ch == '+') ch = getch1();
  if (!isdigit(ch)) return 0;
  i = ch - '0';
  while (ch = getch1(), isdigit(ch))
  { d = ch - '0';
    i0 = i; i = 10 * i + d;
    if (i < i0)
    {grmes(LIN3,	/* "Too many digits" */
		"誮  "); return 0;}
  }
  *p = (neg ? -i : i);
  if (bufposition > 0) bufposition--;
  /* i.e. myungetch1(ch) */
  return 1;
}

static int rdoldnr(int *q)

{ int code, i, pnr;
  code = rdnumber(&i); pnr = abs(i); *q = i;
  if
  (code == 0 || pnr >= nmax ||   pnr  && p[pnr].inuse == 0)
  { grmes(LIN2,	/* "Incorrect point nr." */
		"  窨."); mygetch(); return 0;

  } else return 1;
}

static void reposition(void)
			       /* Requires xwmin etc. to be correct */
	    /* 室, ⮡ 祭 xwmin  .. 뫨 묨 */

{ float Xrange, Yrange, fx, fy, Xcenter, Ycenter,
    x1, y1, z1, q=0.4, xtol, ytol, ztol;
  int i, X, Y;
  x1 = 0.5 * (xwmin + xwmax);
  y1 = 0.5 * (ywmin + ywmax);
  z1 = 0.5 * (zwmin + zwmax);
  xtol = q * (xwmax - xwmin);
  ytol = q * (ywmax - ywmin);
  ztol = q * (zwmax - zwmin);
  if (fabs(xO-x1) > xtol ||
      fabs(yO-y1) > ytol ||
      fabs(zO-z1) > ztol)
  { grmes(LIN3, ",  ...");	/* "Please wait ..." */
    xO = x1; yO = y1; zO = z1;
    newcentralpoint = 1; /* .  'E' */	/* See command 'E' */
    fresh();
    for (i=0; i<nmax+6; i++)		/* . 'clear'  'cursor' */
					/* See 'clear' and 'cursor' */
    { if (p[i].inuse)
      { storepoint(i, p[i].xw, p[i].yw, p[i].zw);
        screencoor(0, i, &X, &Y);
			/* ᫥  祭 xmin  . */
			/* Compute new xmin etc. */
        if (axes)
        { storepoint(nmax+6, p[i].xw, 0.0, 0.0);
          screencoor(0, nmax+6, &X, &Y);
          storepoint(nmax+6, 0.0, p[i].yw, 0.0);
          screencoor(0, nmax+6, &X, &Y);
          storepoint(nmax+6, 0.0, 0.0, p[i].zw);
          screencoor(0, nmax+6, &X, &Y);
        }
        if (auxlines)
        { storepoint(nmax+6, p[i].xw, p[i].yw, 0.0);
          screencoor(0, nmax+6, &X, &Y);
        }
      }
    }
    p[nmax+6].inuse = 0;
    grmes(LIN3, " "); grmes(LIN4, " ");
  }
  Xrange = xmax - xmin; Yrange = ymax - ymin;
  if (Xrange < 1e-12) Xrange = 1e-12;
  if (Yrange < 1e-12) Yrange = 1e-12;
  Xcenter = 0.5*(xmin+xmax); Ycenter = 0.5*(ymin+ymax);
  fx = Xvp_range/Xrange; fy = Yvp_range/Yrange;
  d = (fx < fy ? fx : fy);
  if (!zoomin) d *= 0.85;
		/* Provide some space for new points */
		/* ࢨ    祪 */
  c1 = Xvp_center - d*Xcenter; c2 = Yvp_center - d*Ycenter;
}

static void screencoor(int mode, int i, int *pX, int *pY)

{ double xe, ye, ze, xs, ys;
  xe = p[i].xe; ye = p[i].ye; ze = p[i].ze;
  xs = xe/ze;  ys = ye/ze;
  if (xs < xmin) xmin = xs;
  if (xs > xmax) xmax = xs;
  if (ys < ymin) ymin = ys;
  if (ys > ymax) ymax = ys;
  if (mode == 0) return;
  xxx = d*xs+c1; yyy = d*ys+c2;
  if (!zoomin)
  { if (xxx < Xvp_min || xxx > Xvp_max ||
        yyy < Yvp_min || yyy > Yvp_max) inside = 0;
  }
  *pX = IX(xxx); *pY = IY(yyy);
}

static void show(char c)

{ if (!zoomin)
  { s2[0] = c; textXY(margin + 140, LIN1, s2);
  }
}

static int storepoint(int i, float xw, float yw, float zw)

{ int oldpoint=0;
  double xe, ye, ze;
  if (i < nmax && p[i].inuse)  oldpoint = 1;
  p[i].xw = xw; p[i].yw = yw; p[i].zw = zw;
  if (p[i].inuse == 0) p[i].inuse = 1;
  viewing(xw-xO, yw-yO, zw-zO, &xe, &ye, &ze);
  p[i].xe = xe; p[i].ye = ye; p[i].ze = ze;
  if (xw < xwmin) xwmin = xw;
  if (xw > xwmax) xwmax = xw;
  if (yw < ywmin) ywmin = yw;
  if (yw > ywmax) ywmax = yw;
  if (zw < zwmin) zwmin = zw;
  if (zw > zwmax) zwmax = zw;
  if (ze < zemin) zemin = ze;
  if (ze > zemax) zemax = ze;
  if (i < nmax) object_present = 1;
  return oldpoint;
  /* 㭪 'storepoint' 筮 頥 祭 0; 祭 1 */
  /* 頥  ⮬ 砥, ᫨ 窠 i 㦥 	   */
}

static void textcursor(int col, int line)
{ static char underline[2]="_", dum[2]=" ";
  int j;
  if (char_avail) return;
  do
  { j = 100;
    do textXY(col, line, underline);
      while (--j && !kbhit());
    j = 200;
    do textXY(col, line, dum); while (--j && !kbhit());
  } while (!kbhit());
}

static void transform(void)

{ char ch, str[30];
  int P=-1, Q=-1, R=-1, Pabs=-1, Qabs=-1, Rabs=-1,
      A, B, Aabs, Babs, i, i1, duplicate, refl=0, tmp,
      *pnum, j, j1, n, k, k1, freepos, m, mabs,
      lowest, highest;
  double x, y, z, a, b, c, d, h,
      xP, xQ, xR, yP, yQ, yR, zP, zQ, zR,
      len, fact;
  float alpha=0.0, Sx=1.0, Sy=1.0, Sz=1.0,
      xC, yC, zC, C1, C2, C3,
      xlowest=1.0, xhighest, x1=0.0, y1=0.0, z1=0.0;
  while (nmax > 0 && p[nmax-1].inuse == 0) nmax--;
   grmes(LIN2, "७ (M) ");
   ch = query(LIN3, "  () ?  ");
  if ( ch == 'C' ) grmes(LIN2, " () ");
       duplicate = ( ch == 'C' );
  enquire(LIN3, " ࠭: ", &xlowest);
  lowest = (int)(xlowest + 0.1);
  if (lowest < 1) lowest = 1;
  xhighest = nmax - 1;
  enquire(LIN4, " ࠭: ", &xhighest);
  highest = (int)(xhighest + 0.1);
  if (highest >= nmax) highest = nmax - 1;
  if (duplicate)
  { freepos = nmax;
    check_alloc(nmax + highest - lowest);
  }
  grmes(LIN3, " "); grmes(LIN4, " ");
  ch = query(LIN2, "? (Y/N) ");
  if (ch == 'Y')
  { grmes(LIN1, "  PQ.");
    grmes(LIN2, " 祪 P  Q:");
    bufposition = -1;
    if (!rdoldnr(&P) || !rdoldnr(&Q)) return;
    Pabs = abs(P); Qabs = abs(Q);
    x = p[Pabs].xw; y = p[Pabs].yw; z = p[Pabs].zw;
    x1 = p[Qabs].xw; y1 = p[Qabs].yw; z1 = p[Qabs].zw;
    enquire(LIN2, "  ࠤ:", &alpha);
    alpha = alpha * PIdiv180;
    initrotate(x, y, z, x1 - x, y1 - y, z1 - z, alpha);
    for (i=lowest; i<=highest; i++)
    if (p[i].inuse && (P > 0 || i != Pabs) &&
                      (Q > 0 || i != Qabs))
    { rotate(p[i].xw, p[i].yw, p[i].zw, &x, &y, &z);
      if (duplicate)
      { i1 = freepos++; p[i1].inuse = 1; p[i].inuse = i1;
      } else i1 = i;
      p[i1].xw = x; p[i1].yw = y; p[i1].zw = z;
    }
  } else
  { ch = query(LIN2, "७? (Y/N) ");
    if (ch == 'Y')
    { grmes(LIN2, " ");
      if (query(LIN1, "? (Y/N) ") != 'Y')
      { enquire(LIN1, "delta x = ", &x1);
	enquire(LIN2, "delta y = ", &y1);
	enquire(LIN3, "delta z = ", &z1);
      } else
      { grmes(LIN1, "AB -  ७");
	grmes(LIN2, " 祪 A  B:");
        bufposition = -1;
        if (!rdoldnr(&A) || !rdoldnr(&B)) return;
        Aabs = abs(A); Babs = abs(B);
        x = p[Aabs].xw; y = p[Aabs].yw; z = p[Aabs].zw;
        x1 = p[Babs].xw - x;
        y1 = p[Babs].yw - y;
        z1 = p[Babs].zw - z;
      }
      for (i=lowest; i<=highest; i++)
      if (p[i].inuse &&
         (A > 0 || i != Aabs) && (B > 0 || i != Babs))
      { if (duplicate)
        { i1 = freepos++; p[i1].inuse = 1; p[i].inuse = i1;
        } else i1 = i;
        p[i1].xw = p[i].xw + x1;
        p[i1].yw = p[i].yw + y1;
        p[i1].zw = p[i].zw + z1;
      }
    } else
    { ch = query(LIN2, "⠡? (Y/N) ");
      if (ch == 'Y')
      { if (query(LIN2, "? (Y/N) ") == 'Y')
	{ enquire(LIN3, "Sx=Sy=Sz= ", &Sx); Sy = Sz = Sx;
        } else
	{ grmes(LIN2, " ");
	  enquire(LIN1, "Sx = ", &Sx);
	  enquire(LIN2, "Sy = ", &Sy);
	  enquire(LIN3, "Sz = ", &Sz);
        }
        while (1)
	{ grmes(LIN1, "஢ 窠:");
	  grmes(LIN2, " (C), 砫 (O)");
	  ch = query(LIN3, " 設 (V): ");
          if (ch == 'C')
          { checkall(); xC = xO; yC = yO; zC = zO;
          } else
          if (ch == 'O' || ch == '0')
            xC = yC = zC = 0.0; else
          if (ch == 'V')
	  { grmes(LIN2, " 窨: ");
            bufposition = -1;
            if (!rdoldnr(&P)) return;
            Pabs = abs(P);
            xC = p[Pabs].xw;
            yC = p[Pabs].yw;
            zC = p[Pabs].zw;
          } else continue;
          break;
        }
        C1 = xC * (1.0 - Sx);
        C2 = yC * (1.0 - Sy);
        C3 = zC * (1.0 - Sz);
        for (i=lowest; i<=highest; i++)
        if (p[i].inuse && (P > 0 || i != Pabs))
        { if (duplicate)
          { i1 = freepos++;
            p[i1].inuse = 1; p[i].inuse = i1;
          } else i1 = i;
          p[i1].xw = Sx * p[i].xw + C1;
          p[i1].yw = Sy * p[i].yw + C2;
          p[i1].zw = Sz * p[i].zw + C3;
        }
      } else
      { ch = query(LIN2, "ࠦ? (Y/N) ");
        if (ch == 'Y')
	{ grmes(LIN1, "PQR-. ࠦ.");
	  grmes(LIN2, " 祪 P, Q, R:");
          bufposition = -1; refl = 1;
          if (!rdoldnr(&P) || !rdoldnr(&Q) || !rdoldnr(&R))
            return;
          Pabs = abs(P); Qabs = abs(Q); Rabs = abs(R);
          xP = p[Pabs].xw; yP = p[Pabs].yw; zP = p[Pabs].zw;
          xQ = p[Qabs].xw; yQ = p[Qabs].yw; zQ = p[Qabs].zw;
          xR = p[Rabs].xw; yR = p[Rabs].yw; zR = p[Rabs].zw;
          a = yP*(zQ-zR) + yQ*(zR-zP) + yR*(zP-zQ);
          b = xP*(zR-zQ) + xQ*(zP-zR) + xR*(zQ-zP);
          c = xP*(yQ-yR) + xQ*(yR-yP) + xR*(yP-yQ);
          len = sqrt(a*a+b*b+c*c);
          if (len == 0.0) len = 1e-15;
          a /= len; b /= len; c /= len;
          d = a*xP + b*yP + c * zP;
          for (i=lowest; i<=highest; i++)
          if (p[i].inuse &&
          (P > 0 || i != Pabs) &&
          (Q > 0 || i != Qabs) &&
          (R > 0 || i != Rabs))
          { if (duplicate)
            { i1 = freepos++;
              p[i1].inuse = 1; p[i].inuse = i1;
            } else i1 = i;
            x = p[i].xw; y = p[i].yw; z = p[i].zw;
            h = a*x +b*y + c*z; fact = 2.0 * (d-h);
            p[i1].xw = x + fact * a;
            p[i1].yw = y + fact * b;
            p[i1].zw = z + fact * c;
          }
	} else {grmes(LIN2, " "); return;}
      }
    }
  }
  if (duplicate)
  { grmes(LIN1, "  祪:");
    sprintf(str, "%d-%d", nmax, freepos-1);
    pressanykey(str);
    nmax = freepos;
  }
  grmes(LIN3, ",  ...");
  modified = 1; checkall();
  while (nface >0 && pface[nface-1] == NULL) nface--;
  if (duplicate)
  { if (2*nface >= MAXFACES)
    { grmes(LIN3, "誮  ࠭"); getch(); display();
      return;
    }
    freepos = nface;
    for (j=0; j<nface; j++)
    { if (pface[j] == NULL) continue;
      j1 = freepos++;
      pface[j1] = NULL;
      n = pface[j][0];
      if (n<0) ermes("n<0  㭪樨 transform");
      if ((pface[j1] = (int *)farcalloc(n+1, sizeof(int)))
         == NULL)
	ermes(" 墠⠥ ");
      pface[j1][0] = n;
      for (k=1; k<=n; k++)
      { k1 = (refl ? (n > 3 ? (k < 4 ? 4-k : 4+n-k)
                            : n+1-k)
                   : k);
        m = pface[j][k1]; mabs = abs(m);
        if (mabs < lowest || mabs > highest) break;
        pface[j1][k] =
        (mabs == Pabs && P < 0 ||
         mabs == Qabs && Q < 0 ||
         mabs == Rabs && R < 0
         ? m : (m < 0 ? -p[mabs].inuse : p[m].inuse));
      }
      if (mabs < lowest || mabs > highest)
      { farfree(pface[j1]); freepos--;
      }
    }
    nface = freepos;
  } else
  if (refl)	/* Invert the orientation of all faces: */
		/* ஢ ਥ樨  ࠭: */
  { for (j=0; j<nface; j++)
    { if (pface[j] == NULL) continue;
      n = pface[j][0];
      if (n < 3) continue;
      pnum = pface[j];
      tmp = pnum[1]; pnum[1] = pnum[3]; pnum[3] = tmp;
      k1 = (n - 3)/2;
      for (k=1; k<=k1; k++)
      { tmp = pnum[3+k];
        pnum[3+k] = pnum[n+1-k];
        pnum[n+1-k] = tmp;
      }	 	/* E.g. old: 1 2 3 4 5 6 7 8. */	/*  */
    }   	/*      new: 3 2 1 8 7 6 5 4. */        /*   */
  }    		/* (Any vertex except 2 may be concave)           */
		/* ( 設, ஬ 2,   묨) */
  display();
}

static void viewing(float x, float y, float z,
		     double *pxe, double *pye, double *pze)

{ *pxe = v11*x + v21*y;
  *pye = v12*x + v22*y + v32*z;
  *pze = v13*x + v23*y + v33*z + v43;
  if (*pze <= EPS)
	ermes (".  祭  rho ");
}

static void wrfile(void)

{ int i, j, n, k;
  char ch;
  FILE *fp;
  grmes(LIN2, "室 䠩: ");
  if (kbhit()) getch();
  if (*filnam) grmes(LIN3, filnam);
  textcursor(margin + 8*strlen(filnam)+8, LIN3);
  if (ch = mygetch(), ch != '\n' && ch != '\r')
  { ungetch(ch);
    getstr(margin, LIN3, filnam);
  }
  if (*filnam == '\0' || (fp = fopen(filnam, "w")) == NULL)
  { grmes(LIN3, "  䠩"); return;
  }
  for (i=0; i<nmax; i++)
  if (p[i].inuse)
    fprintf(fp, "%d %f %f %f\n",
                i, p[i].xw, p[i].yw, p[i].zw);
  if (nface > 0)
  { fprintf(fp, "Faces = ࠭:\n");
    for (j=0; j<nface; j++)
    { if (pface[j] == NULL) continue;
      n = pface[j][0];
      if (n < 0) ermes("n<0  㭪樨 wrfile");
      for (k=1; k<=n; k++) fprintf(fp, " %d", pface[j][k]);
      fprintf(fp, ".\n");
    }
  }
  grmes(LIN2, " ");
  grmes(LIN3, " "); grmes(LIN4, " ");
  fclose(fp);
  modified = 0;	/*       */
}

static void zoom(int code)	/* zoom can be called after initgr */
				/* zoom   맢 ᫥ initgr */

{ if (code)  /*  1 = large;  0 = small  */
  { Xvp_min = 0.25; Xvp_max = x_max - 0.25;
    Yvp_min = 0.4; Yvp_max = y_max - 0.4;
  } else
  { Xvp_min = 0.25; Xvp_max = 6.3;	/* To reserve space for commands */
					/* ࢨ஢    */
    Yvp_min = 0.4; Yvp_max = 6.7;
		/* zoom(0) will not be called when pridim = 1 */
		/* so we have x_max = 10.0, y_max = 7.0       */
	/* zoom(0)  㤥 뢠  pridim = 1 */
	/* ⮬  x_max = 10.0, y_max = 7.0       */
  }
  zoomin = code;
  Xvp_range = Xvp_max - Xvp_min;
  Yvp_range = Yvp_max - Yvp_min;
  Xvp_center = 0.5*(Xvp_min + Xvp_max);
  Yvp_center = 0.5*(Yvp_min + Yvp_max);
}