/* DODECA:   ணࠬ ନ ᠭ  
	   㡠,    뢠.

	   This program constructs a dodecahedron and a cube
	   in which it fits.
*/

#include <stdio.h>
#include <math.h>

main()
{ float s, a, h, v, d, tau;
  static float x[21], y[21], z[21];         /* Initially 0 */
  int i;				/* ࢮ砫쭮 0 */
  FILE *fp;
  tau = (sqrt(5.0) + 1)/2;	  /*  tau = 2 * cos(pi/5)  */
	/* Sometimes the letter phi is used instead of tau */
	/*  ਬ 祭  phi   tau */
  s = sqrt(3 - tau)/2;			/* s = sin (pi/5)  */
  a = tau * s;
  h = (2*s+(tau+1)*sqrt(tau+2))/4;    /* Half side of cube */
				  /*  ஭ 㡠 */
  v = (tau - 1) * h;
  d = (tau - 1) * (h - s);
  printf /* "The twelve faces of the dodecahedron are" */
	("\n ࠭    ।⠢  ᮡ ");
  printf /* "pentagons, each fitting in a circle with radius 1." */
	("㣮쭨,\nᠭ  㦭  ࠤᮬ 1.\n");

  printf /* "The sides of these pentagons have length */
	("\n஭  㣮쭨     %f.\n", 2*s);
  printf
	/*  "The dodecahedron fits in a cube with edges of length" */
	(" 뢠     ஭");
    printf(" %f.\n", 2*h);
  x[5] = x[7] = s;
  x[6] = x[8] = -s;
  x[9] = x[10] = h;
  x[11] = x[12] = -h;
  x[13] = x[15] = x[17] = x[19] = a;
  x[14] = x[16] = x[18] = x[20] = -a;
  y[1] = y[3] = -s;
  y[2] = y[4] = s;
  y[5] = y[6] = h;
  y[7] = y[8] = -h;
  y[13] = y[14] = y[17] = y[18] = h-d;
  y[15] = y[16] = y[19] = y[20] = -(h-d);
  z[1] = z[2] = h;
  z[3] = z[4] = -h;
  z[9] = z[11] = s;
  z[10] = z[12] = -s;
  z[13] = z[14] = z[15] = z[16] = v;
  z[17] = z[18] = z[19] = z[20] = -v;
  fp = fopen("dodeca.dat", "w");
  for (i=1; i<=20; i++)
    fprintf(fp, "%3d %f %f %f\n", i, x[i], y[i], z[i]);

  /* The cube in which the dodecahedron fits will have the
     vertex numbers 101, 102, ..., 108:
     ,   뢠 , 㤥 
     設  ࠬ 101, 102, ..., 108:
  */
  fprintf(fp, "101 %f %f %f\n",  h, -h, -h);
  fprintf(fp, "102 %f %f %f\n",  h,  h, -h);
  fprintf(fp, "103 %f %f %f\n", -h,  h, -h);
  fprintf(fp, "104 %f %f %f\n", -h, -h, -h);
  fprintf(fp, "105 %f %f %f\n",  h, -h,  h);
  fprintf(fp, "106 %f %f %f\n",  h,  h,  h);
  fprintf(fp, "107 %f %f %f\n", -h,  h,  h);
  fprintf(fp, "108 %f %f %f\n", -h, -h,  h);
 
  fprintf(fp, "Faces = ࠭:\n");
  fprintf(fp, " 1 15  9 13  2.\n");
  fprintf(fp, " 1  2 14 11 16.\n");
  fprintf(fp, " 5  6 14  2 13.\n");
  fprintf(fp, " 7 15  1 16  8.\n");
  fprintf(fp, "19 10  9 15  7.\n");
  fprintf(fp, "10 17  5 13  9.\n");
  fprintf(fp, "20  8 16 11 12.\n");
  fprintf(fp, "18 12 11 14  6.\n");
  fprintf(fp, " 3  4 17 10 19.\n");
  fprintf(fp, " 4 18  6  5 17.\n");
  fprintf(fp, " 3 20 12 18  4.\n");
  fprintf(fp, " 3 19  7  8 20.\n");
  /* The cube edges are entered as loose line segments:
      㡠 뢠   ⤥ १ :
  */
  fprintf(fp, "101 102.\n102 103.\n103 104.\n104 101.\n");
  fprintf(fp, "105 106.\n106 107.\n107 108.\n108 105.\n");
  fprintf(fp, "101 105.\n102 106.\n103 107.\n104 108.\n");
  fclose(fp);
}


