/* GRPACK:         ᪨ .        Turbo C.
		    ᯮ짮   'huge'.
	  뢮 ॠ :
      - ७ ᪨  (EGA, 640 x 350);
      - 梥⭮ ᪨  (CGA, 640 x 200);
      - ஬ ᪨  Hercules (HGA, 720 x 348);
      . ⠪ :
      L. Ammeraal (1987). 設 䨪  ᮭ .
         ਨ  ᪮ 몥 ⮢ .. 좮.    */

/* GRPACK: A graphics package.
      Turbo C version, to be used in the huge memory model.
      For: Enhanced Graphics Adapter (EGA, 640 x 350)
           Color Graphics Adapter (CGA, 640 x 200)
           Hercules Graphics Adapter (HGA, 720 x 348)
      See also:  L. Ammeraal (1987). Computer Graphics for the IBM PC,
                 Chichester: John Wiley & Sons.                     */

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#ifndef __HUGE__
#error Use huge mem. model.
#endif

union REGS regs;

int in_textmode=1, X__max, Y__max, drawmode=1, adaptype;

FILE *fplot=NULL;

float x_max=10.0, y_max=7.0, horfact, vertfact;

static int old_vid_state, X1, Y1, offset,
   Ystart[350]; /*  350 >=  Ymax + 1 */

static long int startaddress;

static char
   lastchar,
   gtable[12] =
     {53, 45, 46,  7, 91, 2, 87, 87, 2,  3,  0,  0},
   ttable[12] =
     {97, 80, 82, 15, 25, 6, 25, 25, 2, 13, 11, 12},
   zeros[128];             /* implicitly initialized to zero */
			   /*  樠 ﬨ */

void to_text(void);
void textXY(int X, int Y, char *str);

int IX(float x) { return (int)(x*horfact+0.5); }
int IY(float y) { return Y__max-(int)(y*vertfact+0.5); }

static void error(char *str)
	/* Display a message and terminate program execution */
	/* 뢮 ᮮ饭  襭 믮 ணࠬ */

{ if (!in_textmode) to_text();
  printf("%s\n", str); exit(1);
}

void clearpage(void)		/* Clear the graphics screen */
	       /* ࠭ ᪮ ࠦ  ࠭ */

{ int i, n;
  unsigned segsrc, offsrc, segdest;
  n = (adaptype == 1 ? 128 :
       adaptype == 0 ? 256 : 219);
                           /* EGA: 219 x 128 = 28032 */
  segsrc = FP_SEG(zeros); offsrc = FP_OFF(zeros);
  segdest = (adaptype == 2 ? 0xA000 : 0xB800);
  for (i=0; i<n; i++)
  movedata(segsrc, offsrc, segdest, i << 7, 128);
}

int iscolor(void)	   /* Find out which adapter is used */
		  /* । ⨯ ᯮ㥬  */

{ char ch0, ch1, x;
  if (peekb(0x40, 0x87)) return 2;
  /* EGA, see Dr. Dobbs Journal, November 1987, p.34 */
  int86(0x11, &regs, &regs);
  if ((regs.x.ax & 0x30) != 0x30) return 1;           /* CGA */
		    /* Color graphics                        */
		    /* ⭮ ᪨            */
  outport(0x3BF, 3);
		    /* Configuration switch                  */
		    /* ४⥫ 䨣樨            */
  ch0 = *(char *)0xB8000000;
		    /* Try to read ch0 from screen memory    */
		    /* ⪠ ⥭ ch0  ࠭  */
  ch1 = ch0 ^ 0xFF;
		    /* Find some value different from  ch0   */
	   /* । ண ᫠, ⫨筮  ch0 */
  *(char *)0xB8000000 = ch1;
		    /* Try to write this into screen memory  */
	   /* ⪠   ᫮  ࠭    */
  x = *(char *)0xB8000000;
		    /* Try to read the latter value          */
		    /* ⪠  ᫥ 祭  */
  *(char *)0xB8000000 = ch0;
		    /* Restore the old value  ch0            */
		    /* ⠭ ண 祭 ch0   */
  return ( x == ch1 ? 0 : -1);
		    /* Has written value been read?          */
		    /* 뫮  ⠭ ᠭ ᫮?   */
}

static void setgrcon(int adaptype)
				   /* Set graphics constants */
			/* ନ஢ ᪨ ⠭ */

{ int Y, c1, c2, c3;
  startaddress = (adaptype == 2 ? 0xA0000000 : 0xB8000000);
  if (adaptype == 2)
  { X__max = 639; Y__max = 349;
    for (Y=0; Y<=Y__max; Y++) Ystart[Y] = 80 * Y;
    return;
  }
  if (adaptype == 1)
  { X__max = 639; Y__max = 199;
    c1 = 1; c2 = 80; c3 = 1;
  } else
  { X__max = 719; Y__max = 347;
    c1 = 3; c2 = 90; c3 = 2;
  }
  for (Y=0; Y<=Y__max; Y++)
  Ystart[Y] = 0x2000*(Y&c1) + c2*(Y>>c3);
}

static int grbrfun(void)
	   /* Used by  ctrlbrk, to specify what to do with a */
	   /* console  break                                 */
	   /* ᯮ 㭪樥 ctrlbrk  ।, */
	   /*    ᮫쭮 뢠           */

{ to_text(); return 0;
}

static void initcgaorega(int mode)
		 /* Switch to graphics mode (CGA or EGA)     */
       /* ४祭  ᪨ ० (CGA  EGA)     */

{ regs.h.ah = 15;             /* Inquire current video state */
		    /*  ⥪饣 ﭨ ⮡ࠦ */
  int86(0x10, &regs, &regs);
  old_vid_state = regs.h.al;
  regs.h.ah = 0;                        /* Set graphics mode */
			    /* ⠭ ᪮ ० */
  regs.h.al = mode;
		   /* mode = 6:  CGA, 640 x 200, black/white */
		   /*                            ୮/ */
		   /* mode = 16: EGA, 640 x 350, black/white */
		   /*                            ୮/ */
  int86(0x10, &regs, &regs);
}

static void initmongr(void)
	    /* Switch to graphics mode (monochrome graphics) */
   /* ४祭  ᪨ ० (஬ ) */

{ static int firstcall=1;
  int i;
  outport(0x3B8, 0x82);
  for (i=0; i<12; i++)
  { outport(0x3B4, i);
    outport(0x3B5, gtable[i]);
  }
  if (firstcall) { firstcall=0; clearpage(); }
  outport(0x3B8, 0x8A);
}

void initgr(void)		      /* Initialize graphics */
			/* 樠 ᪮  */

{ if (!in_textmode)
    error( /* "initgr is called in graphics mode" */
	    "饭  㭪樨 initgr  ᪮ ०");
  adaptype = iscolor();
  if (adaptype < 0) error( /* "Wrong display adapter" */
			    " ᯫ ");
  ctrlbrk(grbrfun);		  /* Set break trap, Turbo C */
			 /* ⠭ 뢠  Turbo C */
  if (adaptype == 2) initcgaorega(16); /* EGA */ else
  if (adaptype == 1) initcgaorega(6);  /* CGA */ else
  /* adaptype == 0 */ initmongr();     /* HGA */
  setgrcon(adaptype);
  in_textmode=0;
  horfact = X__max/x_max; vertfact = Y__max/y_max;
}

static void endcolgr(void)
	    /* Revert to text mode (color graphics or EGA):  */
	    /*   ⥪⮢ ०                     */
	    /* ( 梥⭮ ᪮   EGA): */

{ regs.h.ah = 0; regs.h.al = old_vid_state;
  int86(0x10, &regs, &regs);
}

static void endmongr(void)
	       /* Revert to text mode (monochrome graphics): */
	       /*   ⥪⮢ ०                  */
	       /* ( ஬ ᪮ ) : */

{ int i;
  char *source;
  unsigned segsrc, offsrc;
  outport(0x3B8, 0);
  for (i=0; i<12; i++)
  { outport(0x3B4, i);
    outport(0x3B5, ttable[i]);
  }
  source =
  "\40\7\40\7\40\7\40\7\40\7\40\7\40\7\40\7";
  segsrc = FP_SEG(source); offsrc = FP_OFF(source);
  for (i=0; i<256; i++)
    movedata(segsrc, offsrc, 0xB000, i << 4, 16);
  outport(0x3B8, 0x08);
}

static int txtbrfun(void)

{ return 0;
}

void to_text(void)		      /* Revert to text mode */
				/*   ⥪⮢ ० */
{ if (in_textmode)
    error( /* "endgr or to_text is called in text mode" */
       "㭪樨 endgr  to_text 맢  ⥪⮢ ०");
  if (adaptype) endcolgr(); /* CGA or EGA */
           else endmongr(); /* HGA        */
  in_textmode = 1;
  ctrlbrk(txtbrfun);
		  /* Restore default break interrupt handler */
	 /* ⠭ ࠡ⪨ 뢠  㬮砭 */
}

void endgr(void)
       /* Wait until any key is hit and revert to text mode  */
       /*    , ᫥ 祣         */
       /*   ⥪⮢ ०                          */

{ getch();
  to_text();
}

void dot(int X, int Y)		  /* Light or darken a pixel */
			    /* ᢥ⪠  襭 ᥫ */

{ int pattern;
  offset = Ystart[Y] + (X>>3);
  lastchar = *(char *)(startaddress + offset);
				/* Turbo C  */   /* ࡮  */
  pattern = 0x80 >> (X&7);
  if (drawmode == 1) lastchar |= pattern; else
  if (drawmode == -1) lastchar &= (~pattern);
                 else lastchar ^=pattern;
  *(char *)(startaddress + offset) = lastchar;
}

static void checkbreak(void)
{ char ch;
  if (kbhit()) { ch = getch(); kbhit(); ungetch(ch); }
}

void draw_line(int X1, int Y1, int X2, int Y2)
	 /* Draw the line segment from (X1, Y1) to (X2, Y2); */
	 /*  X1, Y1, X2, Y2 are pixel coordinates            */
      /* 稢 १ אַ  (X1, Y1)  (X2, Y2); */
      /* X1, Y1, X2, Y2 -  ᥫ न           */

{ int X, Y, T, E, dX, dY, denom, Xinc = 1, Yinc = 1,
  vertlonger = 0, aux;
  checkbreak();       /* To make DOS check for console break */
		   /* ⠭   ᮫쭮 뢠 */
  if (in_textmode)
    error( /* "Not in graphics mode (call initgr)" */
	       "  ᪮ ० (㦥 맮 initgr)");
  dX = X2 - X1; dY = Y2 - Y1;
  if (dX < 0) {Xinc = -1; dX = -dX;}
  if (dY < 0) {Yinc = -1; dY = -dY;}
  if (dY > dX)
  { vertlonger = 1; aux = dX; dX = dY; dY = aux;
  }
  denom = dX << 1;
  T = dY << 1;
  E = -dX; X = X1;
  Y = Y1;
  if (vertlonger)
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { X += Xinc; E -= denom;
    }
    Y += Yinc;
  } else
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { Y += Yinc; E -= denom;
    }
    X += Xinc;
  }
  if (drawmode == 0) dot(X1, Y1);
}

static void fatal(void)
   /* Draw a diagonal, then wait until a key is pressed, and */
   /* finally revert to text mode                            */
   /* 稢     ࠭,  ⥬  */
   /*        ⥫쭮  室 */
   /*  ⥪⮢ ०.                                     */

{ draw_line(0, Y__max,  X__max, 0); endgr();
}

static void check(int X, int Y)
 /* If point (X, Y) lies outside the screen boundaries, then */
 /* call  fatal, display the incorrect coordinates, and stop */
 /* ᫨ 窠 (X, Y)    । ࠭,    맮 */
 /* 㭪樨 fatal, ⮡ࠦ   न  ⠭ */

{ if (X < 0 || X > X__max || Y < 0 || Y > Y__max)
  { fatal();
    printf(
     /* Point outside screen (X and Y are pixel coordinates) */
       "窠  ࠭ (X  Y  ᥫ न):\n");
    printf("X = %d       Y = %d\n", X, Y);
    printf("x = %10.3f   y = %10.3f\n",
    X/horfact, (Y__max-Y)/vertfact);
    printf(
    "X__max = %d  Y__max = %d  x_max = %f y_max = %f\n",
     X__max, Y__max, x_max, y_max);
    printf("horfact = %f  vertfact = % f\n",
            horfact, vertfact);
    exit(1);
  }
}

void move(float x, float y)
			/* Move the current point to (x, y); */
			/* x and y  are  screen  coordinates */
			/* ७ ⥪饩 窨    (x, y); */
			/* x    y    ࠭  न */

{ int XX, YY;
  XX = IX(x); YY = IY(y); check(XX, YY);
  if (fplot != NULL && (XX != X1 || YY != Y1))
    fprintf(fplot, "%6.3f %6.3f 0\n", x, y);
  X1 = XX; Y1 = YY;
}

void draw(float x, float y)
     /* Draw a line segment from the current point to (x, y) */
     /* 稢 १ אַ    ⥪饩  窨 */
     /*   (x, y)                                       */

{ int X2, Y2;
  X2 = IX(x); Y2 = IY(y); check(X2, Y2);
  draw_line(X1, Y1, X2, Y2);
  if (fplot != NULL)
    fprintf(fplot, "%6.3f %6.3f 1\n", x, y);
  X1 = X2; Y1 = Y2;
}

int pixlit(int X, int Y)
			   /* Inquire if pixel (X, Y) is lit */
		   /* ,  ᢥ祭  ᥫ (X, Y) */

{ int pattern;
  offset= Ystart[Y] + (X>>3);
  pattern = 0x80 >> (X&7);
  lastchar = *(char *)(startaddress + offset);
				/* Turbo C  */   /* ࡮  */
  return ((lastchar & pattern) != 0);
}

static void prchar(char ch)
		    /* Send byte ch to parallel printer port */
	   /* 뫪  ch  ࠫ  ਭ */

{ regs.x.dx=0;             /* Printer selection              */
			   /* 롮 ਭ                 */
  regs.h.ah=0;             /* Send byte from AL to printer   */
			   /* 뫪   AL  ਭ */
  regs.h.al=ch;            /* Byte to be sent to printer     */
			   /* , 뫠  ਭ    */
  int86(0x17, &regs, &regs);
}

void printgr(int Xlo, int Xhi, int Ylo, int Yhi)
	    /* Print contents of rectangle on matrix printer */
    /* 뢮 ᮤন אַ㣮쭨   ਭ */

{ int n1, n2, ncols, i, X, Y, val, Xhi1;
  char line[720];                           /* 720 >= X__max */
  regs.x.dx = 0;                            /* LPT1          */
  regs.h.ah = 2;        /* Service 2: Get Printer Status     */
			/*  2: 맮 ﭨ ਭ */
  int86(0x17, &regs, &regs);      /* Printer services        */
				  /* 㦨 ਭ   */
  if ((regs.h.ah & 8) == 8)       /* Printer status in AH    */
				  /* ﭨ ਭ  AH */
  { if (in_textmode) printf( /* "In textmode" */
				" ⥪⮢ ०"); else
    textXY(0, Y__max - 15,            /* "Printer not ready" */
			   "ਭ  ⮢");
    return;
  }
  prchar(27); prchar('1');         /* Line spacing 7/72 inch */
		   /*  ﭨ   ப 7/72  */
  for (i=Ylo; i<=Yhi; i+=7)
  { checkbreak();    /* To make DOS check for console break  */
	  /* ⠭   ஢ન ᮫쭮 뢠 */
    Xhi1 = Xlo-1;
    for (X=Xlo; X<=Xhi; X++)
    { val=0;
      for (Y=i; Y<i+7; Y++)
      { val <<= 1; val |= (Y>Yhi ? 0 : pixlit(X, Y));
      }
      line[X] = val;
      if (val) Xhi1 = X;
    }
    ncols = Xhi1-Xlo+1;
    if (ncols)
    { n1=ncols%256; n2=ncols/256;
      prchar(27); prchar('L'); prchar(n1); prchar(n2);
      for (X=Xlo; X<=Xhi1; X++) prchar(line[X]);
    }
    prchar('\n');
  }
  prchar(27); prchar('@');
}

void setprdim(void)
    /* This function sets x_max and y_max such that graphics */
    /* results  will  eventually  be  printed  with  correct */
    /* dimensions, both horizontally and vertically          */
    /*   㭪  ⠭ ⠪  祭  x_max   */
    /* y_max, ⮡ ᪮ ࠦ 뫮  ⠭ */
    /*    ᮡ  ࠧ஢     ਧ⠫, */
    /* ⠪     ⨪                                  */

{ extern float x_max, y_max;
  extern int X__max, Y__max;
  setgrcon(iscolor());
  x_max = (X__max + 1)/120.0; y_max=(Y__max + 1)/72.0;
}

#define NASCII 256
char chlist[NASCII][11]=
{
  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},	{0},  {0},
  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
/* */   {0},
/*!*/ {0x10, 0x38, 0x38, 0x38, 0x10, 0x10, 0x10,    0, 0x10},
/*"*/ {0x48, 0x48, 0x48},
/*#*/ {0x24, 0x24, 0x64, 0xFE, 0x44, 0xFE, 0x4C, 0x48, 0x48},
/*$*/ {0x10, 0x7C, 0xD0, 0xD0, 0x7C, 0x16, 0x16, 0x7C, 0x10},
/*%*/ {0xC2, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x86},
/*&*/ {0x30, 0x48, 0x48, 0x30, 0x50, 0x92, 0x8A, 0x8C, 0x72},
/*'*/ {0x18, 0x18, 0x18, 0x10},
/*(*/ {0x08, 0x10, 0x20, 0x20, 0x20, 0x20, 0x20, 0x10, 0x08},
/*)*/ {0x40, 0x20, 0x10, 0x10, 0x10, 0x10, 0x10, 0x20, 0x40},
/***/ {   0, 0x82, 0x44, 0x28, 0xFE, 0x28, 0x44, 0x82},
/*+*/ {   0, 0x10, 0x10, 0x10, 0xFE, 0x10, 0x10, 0x10},
/*,*/ {0, 0, 0, 0, 0, 0,    0, 0x30, 0x30, 0x10, 0x20},
/*-*/ {0, 0, 0, 0, 0xFE},
/*.*/ {0, 0, 0, 0, 0, 0,    0, 0x30, 0x30},
/*/*/ {   0, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80},
/*0*/ {0x38, 0x6C, 0x44, 0x44, 0x44, 0x44, 0x44, 0x6C, 0x38},
/*1*/ {0x10, 0x30, 0x50, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38},
/*2*/ {0x7C, 0xC6, 0x02, 0x06, 0x0C, 0x18, 0x30, 0x60, 0xFE},
/*3*/ {0x7C, 0xC6, 0x02, 0x06, 0x0C, 0x06, 0x02, 0xC6, 0x7C},
/*4*/ {0x04, 0x0C, 0x1C, 0x34, 0x64, 0xC4, 0xFE, 0x04, 0x04},
/*5*/ {0xFE, 0x80, 0x80, 0xFC, 0x06, 0x02, 0x02, 0xC6, 0x7C},
/*6*/ {0x7C, 0xC6, 0x80, 0xFC, 0xC6, 0x82, 0x82, 0xC6, 0x7C},
/*7*/ {0xFE, 0x02, 0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0x80},
/*8*/ {0x7C, 0xC6, 0x82, 0xC6, 0x7C, 0xC6, 0x82, 0xC6, 0x7C},
/*9*/ {0x7C, 0xC6, 0x82, 0xC2, 0x7E, 0x02, 0x02, 0x06, 0x7C},
/*:*/ {   0, 0x30, 0x30, 0, 0, 0, 0, 0x30, 0x30},
/*;*/ {0, 0, 0x30, 0x30, 0, 0,    0, 0x30, 0x30, 0x10, 0x20},
/*<*/ {0x04, 0x08, 0x10, 0x20, 0x40, 0x20, 0x10, 0x08, 0x04},
/*=*/ {0, 0, 0, 0, 0xFC, 0, 0, 0xFC},
/*>*/ {0x40, 0x20, 0x10, 0x08, 0x04, 0x08, 0x10, 0x20, 0x40},
/*?*/ {0x78, 0xCC, 0x84, 0x0C, 0x18, 0x10, 0x10, 0,    0x10},
/*@*/ {0x7C, 0xC6, 0x8E, 0x92, 0x92, 0x92, 0x8C, 0xC0, 0x7C},
/*A*/ {0x10, 0x38, 0x6C, 0xC6, 0x82, 0x82, 0xFE, 0x82, 0x82},
/*B*/ {0xFC, 0x86, 0x82, 0x86, 0xFC, 0x86, 0x82, 0x86, 0xFC},
/*C*/ {0x7C, 0xC6, 0x80, 0x80, 0x80, 0x80, 0x80, 0xC6, 0x7C},
/*D*/ {0xFC, 0x86, 0x82, 0x82, 0x82, 0x82, 0x82, 0x86, 0xFC},
/*E*/ {0xFE, 0x80, 0x80, 0x80, 0xF8, 0x80, 0x80, 0x80, 0xFE},
/*F*/ {0xFE, 0x80, 0x80, 0x80, 0xFC, 0x80, 0x80, 0x80, 0x80},
/*G*/ {0x7C, 0xC6, 0x82, 0x80, 0x80, 0x8E, 0x82, 0xC6, 0x7C},
/*H*/ {0x82, 0x82, 0x82, 0x82, 0xFE, 0x82, 0x82, 0x82, 0x82},
/*I*/ {0x38, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38},
/*J*/ {0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0xC6, 0x7C},
/*K*/ {0x86, 0x8C, 0x98, 0xB0, 0xE0, 0xB0, 0x98, 0x8C, 0x86},
/*L*/ {0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xFE},
/*M*/ {0x82, 0xC6, 0xEE, 0xBA, 0x92, 0x82, 0x82, 0x82, 0x82},
/*N*/ {0x82, 0xC2, 0xE2, 0xA2, 0xB2, 0x9A, 0x8E, 0x86, 0x82},
/*O*/ {0x7C, 0xC6, 0x82, 0x82, 0x82, 0x82, 0x82, 0xC6, 0x7C},
/*P*/ {0xFC, 0x86, 0x82, 0x86, 0xFC, 0x80, 0x80, 0x80, 0x80},
/*Q*/ {0x7C, 0xC6, 0x82, 0x82, 0x82, 0x82, 0x92, 0xD6, 0x7C, 0x08, 0x08},
/*R*/ {0xFC, 0x86, 0x82, 0x86, 0xFC, 0x90, 0x98, 0x8C, 0x86},
/*S*/ {0x7C, 0xC6, 0x80, 0xC0, 0x7C, 0x06, 0x02, 0xC6, 0x7C},
/*T*/ {0xFE, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10},
/*U*/ {0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0xC6, 0x7C},
/*V*/ {0x82, 0x82, 0x82, 0xC6, 0x44, 0x6C, 0x28, 0x38, 0x10},
/*W*/ {0x82, 0x82, 0x82, 0x92, 0x92, 0xBA, 0xEE, 0x6C, 0x44},
/*X*/ {0xC6, 0x44, 0x6C, 0x28, 0x38, 0x28, 0x6C, 0x44, 0xC6},
/*Y*/ {0x82, 0x82, 0xC6, 0x6C, 0x38, 0x10, 0x10, 0x10, 0x10},
/*Z*/ {0xFE, 0x04, 0x0C, 0x18, 0x10, 0x30, 0x60, 0x40, 0xFE},
/*[*/ {0x7C, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7C},
/*\*/ {   0, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02},
/*]*/ {0x78, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x78},
/*^*/ {0x10, 0x28, 0x44, 0x82},
/*_*/ {0, 0, 0, 0, 0, 0, 0, 0, 0xFE},
/*`*/ {0x40, 0x20, 0x10, 0x08},
/*a*/ {0, 0,    0, 0x7C, 0x06, 0x7E, 0xC2, 0xC2, 0x7E},
/*b*/ {0x80, 0x80, 0x80, 0xFC, 0x86, 0x82, 0x82, 0x86, 0xFC},
/*c*/ {0, 0,    0, 0x7C, 0xC6, 0x80, 0x80, 0xC6, 0x7C},
/*d*/ {0x04, 0x04, 0x04, 0x7C, 0xC4, 0x84, 0x84, 0xC4, 0x7C},
/*e*/ {0, 0,    0, 0x7C, 0xC6, 0xFE, 0x80, 0xC0, 0x7C},
/*f*/ {0x1C, 0x30, 0x20, 0xFC, 0x20, 0x20, 0x20, 0x20, 0x20},
/*g*/ {0, 0,    0, 0x7A, 0xCE, 0x82, 0x82, 0xC2, 0x7E, 0x06, 0x7C},
/*h*/ {0x80, 0x80, 0x80, 0xFC, 0xC6, 0x82, 0x82, 0x82, 0x82},
/*i*/ {   0, 0x30,    0, 0x30, 0x10, 0x10, 0x10, 0x10, 0x38},
/*j*/ {   0, 0x0C,    0, 0x0C, 0x04, 0x04, 0x04, 0x04, 0x04, 0xCC, 0x78},
/*k*/ {0x40, 0x40, 0x40, 0x46, 0x4C, 0x78, 0x58, 0x4C, 0x46},
/*l*/ {0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38},
/*m*/ {0, 0,    0, 0xEC, 0x92, 0x92, 0x92, 0x92, 0x92},
/*n*/ {0, 0,    0, 0xBC, 0xC6, 0x82, 0x82, 0x82, 0x82},
/*o*/ {0, 0,    0, 0x7C, 0xC6, 0x82, 0x82, 0xC6, 0x7C},
/*p*/ {0, 0,    0, 0xFC, 0x86, 0x82, 0x82, 0x86, 0xFC, 0x80, 0x80},
/*q*/ {0, 0,    0, 0x7C, 0xC4, 0x84, 0x84, 0xC4, 0x7C, 0x04, 0x06},
/*r*/ {0, 0,    0, 0xBC, 0xE6, 0x80, 0x80, 0x80, 0x80},
/*s*/ {0, 0,    0, 0x7C, 0xC0, 0x7C, 0x06, 0x06, 0x7C},
/*t*/ {   0, 0x40, 0x40, 0xF0, 0x40, 0x40, 0x40, 0x66, 0x3C},
/*u*/ {0, 0,    0, 0x84, 0x84, 0x84, 0x84, 0xC4, 0x7E},
/*v*/ {0, 0,    0, 0x82, 0x82, 0xC6, 0x6C, 0x38, 0x10},
/*w*/ {0, 0,    0, 0x82, 0x82, 0x92, 0xBA, 0xEE, 0x44},
/*x*/ {0, 0,    0, 0xC6, 0x6C, 0x28, 0x38, 0x6C, 0xC6},
/*y*/ {0, 0,    0, 0x82, 0x82, 0x82, 0x82, 0xC6, 0x7E, 0x06, 0x7C},
/*z*/ {0, 0,    0, 0xFE, 0x0C, 0x18, 0x30, 0x60, 0xFE},
/*{*/ {0x10, 0x20, 0x20, 0x20, 0x40, 0x20, 0x20, 0x20, 0x10},
/*|*/ {0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10},
/*}*/ {0x20, 0x10, 0x10, 0x10, 0x08, 0x10, 0x10, 0x10, 0x20},
/*~*/ {0, 0,    0, 0x60, 0x92, 0x0C}, {0},
/**/ {0x3E, 0x42, 0x82, 0x82, 0x82, 0xFE, 0x82, 0x82, 0x82},
/**/ {0xFC, 0x80, 0x80, 0xFC, 0x82, 0x82, 0x82, 0x82, 0xFC},
/*B*/ {0xFC, 0x82, 0x82, 0x84, 0xFC, 0x82, 0x82, 0x82, 0xFC},
/**/ {0xFC, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80},
/**/ {0x1C, 0x24, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0xFE, 0x82},
/**/ {0xFC, 0x80, 0x80, 0x80, 0xF8, 0x80, 0x80, 0x80, 0xFC},
/**/ {0x92, 0x92, 0x54, 0x38, 0x38, 0x54, 0x92, 0x92, 0x92},
/**/ {0x3C, 0x42, 0x02, 0x04, 0x3C, 0x02, 0x02, 0x82, 0x7C},
/**/ {0x82, 0x82, 0x86, 0x8E, 0x9A, 0xB2, 0xE2, 0xC2, 0x82},
/**/ {0xBA, 0x82, 0x86, 0x8E, 0x9A, 0xB2, 0xE2, 0xC2, 0x82},
/**/ {0x84, 0x84, 0x84, 0x88, 0xF0, 0x88, 0x84, 0x82, 0x82},
/**/ {0x1E, 0x22, 0x42, 0x42, 0x42, 0x42, 0x42, 0xC2, 0xC2},
/**/ {0x82, 0xC6, 0xEE, 0xBA, 0x92, 0x82, 0x82, 0x82, 0x82},
/**/ {0x82, 0x82, 0x82, 0x82, 0xFE, 0x82, 0x82, 0x82, 0x82},
/**/ {0x7C, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x7C},
/**/ {0xFE, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82},
/**/ {0xFC, 0x82, 0x82, 0x82, 0x82, 0xFC, 0x80, 0x80, 0x80},
/**/ {0x7C, 0x82, 0x80, 0x80, 0x80, 0x80, 0x80, 0x82, 0x7C},
/**/ {0xFE, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10},
/**/ {0x82, 0x82, 0x82, 0x82, 0x82, 0x7E, 0x02, 0x02, 0x7C},
/**/ {0x10, 0x7C, 0x92, 0x92, 0x92, 0x92, 0x7C, 0x10, 0x10},
/**/ {0x82, 0xC6, 0x6C, 0x38, 0x10, 0x28, 0x6C, 0xC6, 0x82},
/**/ {0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x7E, 0x06},
/**/ {0x82, 0x82, 0x82, 0x82, 0x82, 0x7E, 0x02, 0x02, 0x02},
/**/ {0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x7E},
/**/ {0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0xFE, 0x06},
/**/ {0xC0, 0xC0, 0x40, 0x7C, 0x42, 0x42, 0x42, 0x42, 0x7C},
/**/ {0x82, 0x82, 0x82, 0xF2, 0x8A, 0x8A, 0x8A, 0x8A, 0xF2},
/**/ {0x80, 0x80, 0x80, 0xFC, 0x82, 0x82, 0x82, 0x82, 0xFC},
/**/ {0x7C, 0x82, 0x02, 0x02, 0x3E, 0x02, 0x02, 0x82, 0x7C},
/**/ {0x9C, 0xA2, 0xA2, 0xA2, 0xA2, 0xE2, 0xA2, 0xA2, 0x9C},
/**/ {0x3E, 0x42, 0x42, 0x42, 0x42, 0x3E, 0x22, 0x42, 0x82},
/**/ {0, 0,    0, 0x78, 0x04, 0x7C, 0x84, 0x84, 0x7A},
/**/ {0, 0, 0x78, 0x80, 0xF8, 0x84, 0x84, 0x84, 0x78},
/**/ {0, 0,    0, 0xF8, 0x84, 0xF8, 0x84, 0x84, 0xF8},
/**/ {0, 0,    0, 0xFC, 0x80, 0x80, 0x80, 0x80, 0x80},
/**/ {0, 0, 0x78, 0x04, 0x7C, 0x84, 0x84, 0x84, 0x78},
/**/ {0, 0,    0, 0x78, 0x84, 0x84, 0xF8, 0x80, 0x7C},
/**/ {0, 0,    0, 0x92, 0x54, 0x38, 0x38, 0x54, 0x92},
/**/ {0, 0,    0, 0x78, 0x84, 0x18, 0x04, 0x84, 0x78},
/**/ {0, 0,    0, 0x84, 0x8C, 0x94, 0xA4, 0xC4, 0x84},
/**/ {0, 0, 0x30, 0x84, 0x8C, 0x94, 0xA4, 0xC4, 0x84},
/**/ {0, 0,    0, 0x84, 0x88, 0xF0, 0x88, 0x84, 0x82},
/**/ {0, 0,    0, 0x3C, 0x44, 0x44, 0x44, 0x44, 0x84},
/**/ {0, 0,    0, 0x82, 0xC6, 0xAA, 0x92, 0x82, 0x82},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0xFC, 0x84, 0x84},
/**/ {0, 0,    0, 0x78, 0x84, 0x84, 0x84, 0x84, 0x78},
/**/ {0, 0,    0, 0xFC, 0x84, 0x84, 0x84, 0x84, 0x84},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
/**/ {0, 0,    0, 0xF8, 0x84, 0x84, 0x84, 0x84, 0xF8, 0x80, 0x80},
/**/ {0, 0,    0, 0x78, 0x84, 0x80, 0x80, 0x84, 0x78},
/**/ {0, 0,    0, 0xFE, 0x10, 0x10, 0x10, 0x10, 0x10},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0x84, 0x84, 0x7C, 0x04, 0x78},
/**/ {0, 0, 0x10, 0x7C, 0x92, 0x92, 0x92, 0x92, 0x7C, 0x10, 0x10},
/**/ {0, 0,    0, 0x84, 0x48, 0x30, 0x30, 0x48, 0x84},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0x84, 0x84, 0x7E, 0x06},
/**/ {0, 0,    0, 0x84, 0x84, 0x84, 0x7C, 0x04, 0x04},
/**/ {0, 0,    0, 0x92, 0x92, 0x92, 0x92, 0x92, 0x7E},
/**/ {0, 0,    0, 0x92, 0x92, 0x92, 0x92, 0x92, 0x7E, 0x03},
/*'*/ {0, 0,    0, 0xC0, 0x40, 0x78, 0x44, 0x44, 0x78},
/**/ {0, 0,    0, 0x82, 0x82, 0xF2, 0x8A, 0x8A, 0xF2},
/**/ {0, 0,    0, 0x80, 0x80, 0xF8, 0x84, 0x84, 0xF8},
/**/ {0, 0,    0, 0x78, 0x84, 0x04, 0x3C, 0x84, 0x78},
/**/ {0, 0,    0, 0x98, 0xA4, 0xA4, 0xE4, 0xA4, 0x98},
/**/ {0, 0,    0, 0x3C, 0x44, 0x44, 0x3C, 0x44, 0x84},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0},
	{0},  {0},  {0},  {0},  {0},  {0},  {0},  {0} };

void textXY(int X, int Y, char *str)
		    /* Display string  str in graphics mode, */
		    /* starting at point (X, Y).             */
		    /* ⮡ࠦ ⥪⮢ ப str,     */
		    /* 稭   窨 (X, Y).      */

{ char *p;
  int offset, i, j, len, hpos, vpos;
  len=strlen(str);
  hpos = X>>3;
  check(8*(hpos+len)-1, Y+10);
  for (i=0; i<len; i++)
  { p=chlist[str[i]];
    for (j=0; j<11; j++)
    { vpos=Y+j;
      offset= Ystart[vpos] + hpos + i;
      *(char *)(startaddress + offset) = p[j];
    }

  }
}

void text(char *str)
		    /* Display string  str, starting at      */
		    /* the current point (X1, Y1).           */
		    /* ⮡ࠦ ⥪⮢ ப str,     */
		    /* 稭  ⥪饩 窨 (X1, Y1).     */

{ textXY(X1, Y1, str);
  X1 += strlen(str) * 8;
  check(X1, Y1);
}

void imove(int X, int Y)
		     /* Let (X, Y) be the new current point */
		     /*  (X, Y) -  ⥪ 窠 */

{ check(X, Y); X1=X; Y1=Y;
}

void idraw(int X, int Y)
     /* Draw a line segment from the current point to (X, Y) */
     /* 稢  १ אַ    ⥪饩 窨 */
     /*   (X, Y)                                       */

{ check(X, Y);
  draw_line(X1, Y1, X, Y);
  X1=X; Y1=Y;
}

#define B000 (char *)0xB0000000
#define B800 (char *)0xB8000000

void wrscr(int row, int col, char *str)	      /* In textmode */
				       /*  ⥪⮢ ० */
     /* Writes characters into video display memory while in */
     /* text mode.                                           */
     /*  ᨬ    ᯫ   ࠡ  */
     /* ⥪⮢ ०
     /*    row = 0, 1, ..., 24;  col = 0, 1, ..., 79         */

{ static char *displayptr;
  static int first=1;
  int i, offset;
  char *p;
  if (first)
  { displayptr = (iscolor() ? B800 : B000);
    first=0;
  }
  offset = row*160+col*2;
  p = displayptr+offset;
  for (i=0; str[i]; i++) p[i << 1] = str[i];
}

void clearscr(void)
	 /* To be used in textmode.                          */
	 /* Don't confuse this with clearpage, to be used in */
	 /* graphics mode                                    */
	 /*  ᯮ짮  ⥪⮢ ०.        */
	 /*  ᫥   㭪樥 clearpage,   */
	 /* ਬ  ᪮ ०                 */

{ static unsigned segdst;
  static first=1;
  int i;
  char *source;
  unsigned segsrc, offsrc;
  if (first)
  { segdst = (iscolor() ? 0xB800 : 0xB000);
    first = 0;
  }
  source =
  "\40\7\40\7\40\7\40\7\40\7\40\7\40\7\40\7";
  segsrc = FP_SEG(source); offsrc = FP_OFF(source);
  for (i=0; i<256; i++)
    movedata(segsrc, offsrc, segdst, i << 4, 16);
}

void settxtcursor(int row, int col)
		     /* Set cursor in textmode               */
		     /* ⠭   ⥪⮢ ० */

{ regs.h.dh = row;
  regs.h.dl = col;
  regs.h.ah = 2;
  regs.h.bh = 0;
  int86(0x10, &regs, &regs);
}