/* GRPACK1:
     ᪨ , ᯮ騩 ᪨ 㭪樨,
     㯭   ࡮  ᨨ 1.5.
      : Huge (  ᯮ㥬 㫥).
     ᯥ稢 ࠡ:
               ७ ᪮  (EGA, 640 x 350)
               ⭮ ᪮  (CGA, 640 x 200)
               ᪮  㫥 (HGA, 720 x 348)

     A graphics package, using Turbo C graphics functions,
     available in Version 1.5.
     Memory model: Huge.
     For: Enhanced Graphics Adapter (EGA, 640 x 350)
                Color Graphics Adapter (CGA, 640 x 200)
                Hercules Graphics Adapter (HGA, 720 x 348)
*/
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#include <alloc.h>
#include <graphics.h>

union REGS regs;

int in_textmode=1, X__max, Y__max, drawmode=1, adaptype;

FILE *fplot=NULL;

float x_max=10.0, y_max=7.0, horfact, vertfact;

static int X1, Y1, foregroundcol, backgroundcol,
   g_driver, g_mode;

static long int startaddress;

void to_text(void);
void textXY(int X, int Y, char *str);

int IX(float x) { return (int)(x*horfact+0.5); }
int IY(float y) { return Y__max-(int)(y*vertfact+0.5); }

static void error(char *str)
     /* Display a message and terminate program execution */
     /* ⮡ࠦ ᮮ饭  믮 ணࠬ 蠥 */

{ if (!in_textmode) to_text( );
  printf("%s\n", str); exit(1);
}

void clearpage(void)          /* Clear the screen */
                    /* ⪠ ࠭ */
{ clearviewport( );
}

int iscolor(void)   /* Find out which adapter is used */
               /* । ⨯ ᯮ㥬  */

{ detectgraph(&g_driver, &g_mode);
  if (g_mode == MCGAHI) g_mode = MCGAMED;
  if (g_mode == ATT400HI) g_mode = ATT400MED;
  if (g_mode == VGAHI) g_mode = VGAMED;
  return g_driver == CGA || g_driver == MCGA ||
         g_driver == ATT400 ?
           1 /* 640 x 200 */ :
         g_driver == EGA || g_driver == EGA64 ||
         g_driver == EGAMONO || g_driver == VGA ?
           2 /* 640 x 350 */ :
         g_driver == HERCMONO ? 0 /* 720 x 348 */ : -1;
}

static void setgrcon(int adaptype) /* Set graphics constants */
                    /* ⠭ ᪨ ⠭ */

{ startaddress = (adaptype == 2 ? 0xA0000000 : 0xB8000000);
  if (adaptype == 2)
  { X__max = 639; Y__max = 349;   /* EGA */
  } else
  if (adaptype == 1)
  { X__max = 639; Y__max = 199;   /* CGA */
  } else
  { X__max = 719; Y__max = 347;   /* HGA */
  }
}

static int grbrfun(void)
/* Used by  ctrlbrk, to specify what to do with a console break
   ᯮ  㭪樨 'ctrlbrk'  । 権,
   믮塞  ᮫쭮 뢠               */

{ to_text( ); return 0;
  /* Before exit, return to text mode!
     室  ⥪⮢ ० । 室 !
  */
}

void initgr(void)   /* Initialize graphics */
               /* 樠 ᪮ ० */
{ static int again=0;
  int errcode;
  if (again) setgraphmode(g_mode); else
  { adaptype = iscolor( );    /* Detects driver and mode */
                    /* । ࠩ  ० */
    if (adaptype < 0) error /* "Wrong display adapter" */
                    (" ᯫ ");
    ctrlbrk(grbrfun);   /* Set break trap, Turbo C   */
               /* ⠭ ணࠬ 뢠  ࡮  */
    initgraph(&g_driver, &g_mode, "\\turboc");
    errcode = graphresult( );
    if (errcode < 0)
    { printf /* "Graphics error code */
     (" 訡  ᪮ : %d", errcode); exit(1);
    }
    again = 1;
    setgrcon(adaptype);
  }
  horfact = X__max/x_max; vertfact = Y__max/y_max;
  if (adaptype == 0) /* HCG */
  { setvisualpage(1); setactivepage(1);
  }
  in_textmode=0;
  foregroundcol=getcolor( );
  backgroundcol=getbkcolor( );
}

static int txtbrfun(void)
{ return 0;
}

void to_text(void)            /* Revert to text mode */
                         /*   ⥪⮢ ० */

{ if (!in_textmode) restorecrtmode( );
  in_textmode = 1;
  ctrlbrk(txtbrfun);
          /* Restore default break interrupt handler */
          /* ⠭ ࠡ稪 뢠  㬮砭 */
}

void endgr(void)
          /* Wait until any key is hit and revert to text mode  */
     /*       室  ⥪⮢ ० */

{ getch( );
  to_text( );
}

void dot(int X, int Y)             /* Light or darken a pixel */
                    /* ᢥ⪠  襭 ᥫ */
{ putpixel
  (X, Y,
    (drawmode == 0 ?
      ( getpixel(X, Y) == foregroundcol ?
        backgroundcol : foregroundcol
      ) :
      ( drawmode == 1 ? foregroundcol : backgroundcol
      )
    )    /* drawmode =  1: draw positively  =  ᢥ⪠    */
  );     /* drawmode = -1: draw negatively  =  襭       */
}        /* drawmode =  0: toggle           =  ४祭 */


void checkbreak(void)
{ char ch;
  if (kbhit( )) { ch = getch( ); kbhit( ); ungetch(ch); }
}

void draw_line(int X1, int Y1, int X2, int Y2)
     /* Draw the line segment from (X1, Y1) to (X2, Y2);
        X1, Y1, X2, Y2 are pixel coordinates  */
     /* 祭 १ אַ  (X1, Y1)  (X2, Y2),
         X1, Y1, X2, Y2  ᥫ न  */

{ if (drawmode == 1) line(X1, Y1, X2, Y2);
     /* 'drawmode' values 0 and -1 not implemented for
        this function. See also dot( )            */
     /* 祭 0  -1  ࠬ 'drawmode'  ⮩
        㭪樨  ਬ. . ⠪ 㭪 'dot( )'.     */
}

static void fatal(void)
     /* Draw a diagonal, then wait until a key is pressed,
        and finally revert to text mode           */
     /* 뢮      ,
        ᫥ 祣 ⥫ 室  ⥪⮢ ०  */

{ draw_line(0, Y__max,  X__max, 0); endgr( );
}

static void check(int X, int Y)
     /* If point (X, Y) lies outside the screen boundaries, then
        call fatal, display the incorrect coordinates, and stop */
     /* ᫨ 窠 (X, Y)  ࠭ ࠭,  맮 㭪樨
        'fatal', ⮡ࠦ ࠢ न  ⠭   */

{ if (X < 0 || X > X__max || Y < 0 || Y > Y__max)
  { fatal( );
    printf /* Point outside screen (X and Y are pixel coordinates) */
     ("窠  ࠭ (X  Y  ᥫ न):\n");
    printf("X = %d       Y = %d\n", X, Y);
    printf("x = %10.3f   y = %10.3f\n",
            X/horfact, (Y__max-Y)/vertfact);
    printf(
    "X__max = %d  Y__max = %d  x_max = %f y_max = %f\n",
            X__max, Y__max, x_max, y_max);
    printf("horfact = %f  vertfact = % f\n",
            horfact, vertfact);
    exit(1);
  }
}

void move(float x, float y)
/* Move the current point to (x, y); x and y are screen coordinates  */
/* ७ ⥪饩 窨  (x, y); x  y  ࠭ न       */

{ int XX, YY;
  XX = IX(x); YY = IY(y); check(XX, YY);
  if (fplot != NULL && (XX != X1 || YY != Y1))
    fprintf(fplot, "%6.3f %6.3f 0\n", x, y);
  X1 = XX; Y1 = YY;
}


void draw(float x, float y)
     /* Draw a line segment from the current point to  (x, y)   */
     /* 祭 १ אַ  ⥪饩 窨   (x, y) */
{ int X2, Y2;
  X2 = IX(x); Y2 = IY(y); check(X2, Y2);
  draw_line(X1, Y1, X2, Y2);
  if (fplot != NULL)
  fprintf(fplot, "%6.3f %6.3f 1\n", x, y);
  X1 = X2; Y1 = Y2;
}

int pixlit(int X, int Y)
               /* Inquire if pixel (X, Y) is lit */
               /* ,  ᢥ祭  ᥫ (X, Y) */

{ return (getpixel(X, Y) == foregroundcol);
}

static void prchar(char ch)
          /* Send byte ch to parallel printer port */
     /* 뫪  ch  ࠫ  ਭ */

{ regs.x.dx=0;      /* Printer selection            */
               /* 롮ઠ ਭ        */
  regs.h.ah=0;      /* Send byte from AL to printer   */
               /* 뫪   AL  ਭ */
  regs.h.al=ch;          /* Byte to be sent to printer   */
               /*   뫪  ਭ       */
  int86(0x17, &regs, &regs);
}

void printgr(int Xlo, int Xhi, int Ylo, int Yhi)
     /* Print contents of rectangle on matrix printer */
     /*   筮 ਭ ᮤন אַ㣮쭨 */

{ int n1, n2, ncols, i, X, Y, val, Xhi1;
  char line[720];                 /* 720 >= X__max */
  regs.x.dx = 0;                  /* LPT1          */
  regs.h.ah = 2;  /* Service 2: Get Printer Status */
          /*  2: 롮ઠ ﭨ ਭ */
  int86(0x17, &regs, &regs);  /* Printer services  */
                    /*  ਭ */
  if ((regs.h.ah & 8) == 8)   /* Printer status in AH */
               /* 뫪 ﭨ ਭ  AH */
  { if (in_textmode) printf /* "In textmode" */
                    (" ⥪⮢ ०"); else
    textXY(0, Y__max - 15,  /* "Printer not ready" */
                   "ਭ  ⮢");
    return;
  }
  prchar(27); prchar('1');    /* Line spacing 7/72 inch */
                    /*  ப 7/72  */
  for (i=Ylo; i<=Yhi; i+=7)
  { checkbreak( );  /* To make DOS check for console break   */
               /* ஢ઠ ᮫쭮 뢠   */
    Xhi1 = Xlo-1;
    for (X=Xlo; X<=Xhi; X++)
    { val=0;
      for (Y=i; Y<i+7; Y++)
      { val <<= 1; val |= (Y>Yhi ? 0 : pixlit(X, Y));
      }
      line[X] = val;
      if (val) Xhi1 = X;
    }
    ncols = Xhi1-Xlo+1;
    if (ncols)
    { n1=ncols%256; n2=ncols/256;
      prchar(27); prchar('L'); prchar(n1); prchar(n2);
      for (X=Xlo; X<=Xhi1; X++) prchar(line[X]);
    }
    prchar('\n');
  }
  prchar(27); prchar('@');
}

void setprdim(void)
/* This function sets x_max and y_max such that graphics
   results will eventually be printed with correct
   dimensions, both horizontally and vertically */
/*  ⮩ 㭪樨 ⠭ ⠪ 祭 x_max  y_max,
    ᪨ १ 㤥 뢥    ᮡ
    ᮮ⭮襭 ࠧ஢  ਧ⠫   ⨪     */
{ extern float x_max, y_max;
  extern int X__max, Y__max;
  setgrcon(iscolor( ));
  x_max = (X__max + 1)/120.0; y_max=(Y__max + 1)/72.0;
}

void textXY(int X, int Y, char *str)
/* Display string str in graphics mode, starting at point (X, Y).
   ⮡ࠦ ப str  ᪮ ०, 稭  窨 (X, Y) */

{ int height, width;
  height = textheight(str); width = textwidth(str);
  setviewport(X, Y, X+width, Y+height, 0);
  clearviewport( );      /* To erase old text, if any */
               /* ࠭ ண ⥪, ᫨   */
  outtext(str);
  setviewport(0, 0, X__max, Y__max, 0);
}

void text(char *str)
/* Display string  str, starting at the current point (X1, Y1).
   ⮡ࠦ ப str, 稭  ⥪饩 窨 (X1, Y1   */

{ textXY(X1, Y1, str);
  X1 += strlen(str) * 8;
  check(X1, Y1);
}

void imove(int X, int Y)
          /* Let (X, Y) be the new current point */
          /*  (X, Y) 㤥  ⥪饩 窮 */

{ check(X, Y); X1=X; Y1=Y;
}

void idraw(int X, int Y)
     /* Draw a line segment from the current point to (X, Y)  */
     /* 祭 १ אַ  ⥪饩 窨   (X, Y) */

{ check(X, Y);
  draw_line(X1, Y1, X, Y);
  X1=X; Y1=Y;
}

void wrscr(int row, int col, char *str) /* In textmode */
                         /*  ⥪⮢ ० */
/* Writes characters into video display memory while in text mode.
     ᨬ   ᯫ  ⥪⮢ ०.
    row = 0, 1, ..., 24;  col = 0, 1, ..., 79
*/
{ gotoxy(col+1, row+1);
  cputs(str);
}

void clearscr(void)
/* To be used in textmode.
   Don't confuse this with clearpage, to be used in graphics mode
    ᯮ짮  ⥪⮢ ०.
      㭪樥 'clearpage', ਬ塞  ᪮ ०.
*/
{ clrscr( );
}

void settxtcursor(int row, int col)
                    /* Set cursor in textmode */
                    /* ⠭   ⥪⮢ ० */
{ gotoxy(col+1, row+1);
}

void far * far _graphgetmem(unsigned size)
{ char *p;
  p = farmalloc((long)size);
  if (p == NULL) error /* "Mem. space in _graphgetmem" */
               (" 墠⠥   㭪樨 '_graphgetmem'");
  return p;
}

void far _graphfreemem(void far *ptr, unsigned size)
{ farfree(ptr);
}