/* ICOSA:   : ࠢ ࠭  20 ࠭ﬨ, 
	      ।⠢ ᮡ ࠢ஭ 㣮쭨.
	    Icosahedron: a regular polyhedron with 20 boundary
	    faces, which are equilateral triangles.
*/

#include <stdio.h>
#include <math.h>

#define p(i, x, y, z) fprintf(fp,"%d %f %f %f\n",i,x,y,z)
#define face(i, j, k) fprintf(fp, "%d %d %d.\n", i, j, k)

main()
{ FILE *fp;
  int i;
  double s, pi, r, alpha, tau;
  pi = 4 * atan(1.0);
  tau = (sqrt(5.0) + 1)/2; /* tau = 2 * cos(pi/5);       */
  s = sin(pi/5);           /* pi/5 radians = 36 degrees  */
  r = tau - 0.5;           /* pi/5 ࠤ  = 36 ࠤᮢ */
  printf /* "Ten of the twelve vertices of the icosahedron" */
	("   設    \n");
  printf /* "lie on two horizontal pentagons, either of which" */
	("ਧ⠫  㣮쭨,     \n");
  printf /* "fits in a circle with radius 1." */
	("뢠  㦭  ࠤᮬ 1.\n\n");
  printf /* "These two pentagons lie a distance 1 apart." */
	("  㣮쭨 ᯮ  ﭨ 1.0\n");
  printf /* "The edges have length " */
	("  㣠.    %f.\n", 2*s);
  printf  /* "The icosahedron fits in a sphere with radius" */
	(" 뢠    ࠤᮬ %f.\n", r);
  fp = fopen("icosa.dat", "w");
  p(1, 0.0, 0.0, r);	 /* North pole */    /*   */
  for (i=0; i<5; i++)
  { alpha = -pi/5 + i * pi/2.5;
		  /*   ࠤ (In degrees): -36 + i * 72 */
    p(2+i, cos(alpha), sin(alpha), 0.5);
  }
  for (i=0; i<5; i++)
  { alpha = i * pi/2.5;
    p(7+i, cos(alpha), sin(alpha), -0.5);
  }
  p(12, 0.0, 0.0, -r);    /* South pole */     /*   */
  fprintf(fp, "Faces = ࠭:\n");
  for (i=0; i<5; i++) face(1, 2+i, i<4 ? 3+i : 2);
  for (i=0; i<5; i++) face(2+i, 7+i, i<4 ? 3+i : 2);
  for (i=0; i<5; i++) 
              face(7+i, i<4 ? 8+i : 7, i<4 ? i+3 : 2);
  for (i=0; i<5; i++) face(i+7, 12, i<4 ? i+8 : 7);
}