/*PLOTHP :      ணࠬ 뢮 ⥦  .
       ᭮ 祭 ⮩ ணࠬ 砥  ८ࠧ
       室 䠩  ,  xxx.plt,  ⥦  
         .  ஬ ⮣,    ⥦   
       뢥  ᯫ  ⯥⠭  筮 ਭ.
       室 䠩    ⥪⮢ ப 

		 x    y    c

       न x  y      ⥫  ⢥
       ᥫ, 筮   10.0  7.0 ᮮ⢥⢥,     
         0 ( ),  1 ( 饭).

     The main purpose  of  this program  is to transform  an input file
     xxx.PLT  to a drawing on  a Hewlett-Packard plotter.  Besides,  it
     can display the same drawing on the video display  and print it on
     a matrix printer. The input file must consist of lines of the form

              x   y   c

     The coordinates x and y are nonnegative real numbers, typically not
     greater than 10.0 and 7.0, respectively,  and the code  c is either
     0 (pen up) or 1 (pen down).
*/
#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <ctype.h>
#include <process.h>
#include "grpack.h"

void display(int printer);
void plotter(void);
void initplotter(void);
float scalingfactor(void);
void ser_str(char *p);
void ser_char(char ch);
void initialize(void);
char getcapital(void);

FILE *fp;
char filnam[40];
unsigned char byte;
int penposition, port;


main()
{ char ch;
  printf /* "Name of input file:" */
       ("\n 室 䠩 : "); scanf("%s", filnam);
  fp = fopen(filnam, "r");
  if (fp == NULL) {printf /* "File problem" */
			("\n  䠩\n"); exit(1);}
  printf  /* "Output on video display?" */
	  ("\n뢮  ᯫ? (Y/N)      : ");
  ch = getcapital();
  if (ch == 'Y')
  { printf /* "Output on matrix printer?" */
	  ("\n뢮   ਭ? (Y/N) : ");
    ch = getcapital();
    display(ch == 'Y');
    fclose(fp); fp = NULL;
  }
  printf  /* "Output on HP plotter?" */
	("\n뢮   HP? (Y/N)        : ");
  ch = getcapital();
  if (ch == 'Y')
  { if (fp == NULL)
    { fp = fopen(filnam, "r");
      if (fp == NULL){printf /* "File problem" */
			("\n  䠩\n"); exit(1);}
    }
    plotter();
  }
  exit(0);                 /* ⨥ 䠩 fp,᫨    */
			   /* Close file fp, if open               */
}

void display(int printer)
{ float f, x, y, xfact, yfact, fact;
  char ch, code;
  f = scalingfactor();
  if (printer) setprdim(); /*  x_max  y_max (⨯ float) */
			   /* Change x_max and y_max (float)       */
  initgr();                /* ⠭ X__max  Y__max (⨯ int) */
			   /* Set X__max and Y__max (int)          */
  xfact = f*x_max/10.0; yfact = f*y_max/7.0;
  fact = (xfact < yfact ? xfact : yfact);
  while (fscanf(fp, "%f %f %d", &x, &y, &code) == 3)
  { ch = getc(fp);
    if (code < 0 || code > 1 || ch != '\n')
    { textXY(40, 40, /* "Incorrect file format" */
			" ଠ 䠩"); endgr();
      exit(1);
    }
    x *= fact; y *= fact;
    if (x > x_max || y > y_max)
    { to_text();
      printf /* "Outside boundaries" */
	     ("\n譨 ࠭:  x = %6.3f  y = %6.3f\n", x, y);
      return;
    }
    if (code) draw(x, y); else move(x, y);
  }
  if (printer) printgr(0, X__max, 0, Y__max);
  endgr();
}

void plotter(void)
{ float f, x, y;
  int ix, iy, code, count=0, velo;
  char str[50], ch;
  initplotter();
  printf  /* "The scaling factor f for a plotter is normally quite
	    large. For example, if x or y ranges from 0 to 10 in the
	    input file, and is to range fromm  0 to 8000  in plotter
	    coordinates, then the scaling factor f should be 800.  */
	("\n樥 ⠡஢ f   筮 祭"
	 "让.\nਬ, ᫨  室 䠩 न x "
	 " y     0  10,\n  न ");
	printf("     0  8000,\n "
	 "樥 ⠡஢ f   ࠢ 800.\n");
  f = scalingfactor();
  printf /* "Default velocity?" */
	("\n  㬮砭? (Y/N) : "); ch = getcapital();
  if (ch == 'N')
  { printf /* "Enter an integer, the velocity in cm/s"
	       "(not less than 1 or greater than 127):" */
  ("\n 楫 ᫮, ।饥 ᪮  /"
     " (  1    127) : ");
    scanf("%d", &velo);
    sprintf(str, "VS%d;", velo);
    ser_str(str);
  }
  while (fscanf(fp, "%f %f %d", &x, &y, &code) == 3)
  { ch = getc(fp);
    if (code < 0 || code > 1 || ch != '\n')
    { printf /* "Incorrect file format" */
	  ("\n ଠ 䠩"); exit(1);
    }
    count++;
    ix = (int)(f * x + 0.5);
    iy = (int)(f * y + 0.5);
    if (code != penposition)
    { ser_str(code ? "PD;" : "PU;");
      penposition = code;
    }
    sprintf(str, "PA%04d,%04d;", ix, iy);
    ser_str(str);
  }         /* points */
  printf("\n%d 祪\n", count); ser_str("PU;");
}

void initplotter(void)
{ FILE *fplconfg;
  int code, comnr, baud, parity, stopbits, charsize,
     oldvalues=0, retval;
  char answer='Y';
  fplconfg = fopen("plconfig.txt", "r");
  if (fplconfg != NULL)
    oldvalues = (fscanf(fplconfg, "%d %d %d %d %d",
    &comnr, &baud, &parity, &stopbits, &charsize) == 5);
  if (oldvalues)
  { printf /* "Default serial port parameters:" */
	 ("\n\nࠬ ᫥⥫쭮   㬮砭:\n\n");
    printf /* "Serial port number:" */
	 (" ᫥⥫쭮 : %4d\n", comnr);
    printf /* "Baud rate:" */
	 ("  :              %4d\n", baud);
    printf /* "Parity:" */
	 ("஢ઠ  ⭮:          %4s\n",
		/* "even"           "odd"     "none"  */
    (parity == 2 ? "" : parity ? "" : ""));
    printf /* "Number of stop bits:" */
	 ("⢮ ⮯ :       %4d\n", stopbits);
    printf /* "Character size:" */
	 ("  ᨬ:       %4d bits\n", charsize);
    printf /* "Are these correct?" */
	 (" ࠢ쭮? (Y/N) : ");
    answer = getcapital();
    printf("\n");
  }
  if (oldvalues == 0 || answer == 'N')
  { printf(
   /* "Enter serial port number (1 for com1, 2 for com2):" */
   "\n  ᫥⥫쭮   (1  com1, 2  com2) : ");
    scanf("%d", &comnr);
    printf /* "Baud rate" */ ("   ? ");
    printf("(110, 150, 300, 600, 1200, 2400, 4800, 9600) : ");
    scanf("%d", &baud);
    printf
     /* "If not sure, try the following options in the given order:" */
     ("\n᫨  㢥७,  ஡ ᫥騥 祭 "
       " 㪠 浪:\n\n");
    printf /* "Parity (0 = none, 1 = odd, 2 = even):" */
	 ("஢ઠ  ⭮ (0 = , 1 = , 2 = ) : ");
    scanf("%d", &parity);
    printf /* "Number of stop bits? (1 or 2):" */
	 ("⢮ ⮯ ? (1  2) : ");
    scanf("%d", &stopbits);
    printf /* "Character size (8 or 7):" */
	 ("  ᨬ ( 8    7 ) : ");
    scanf("%d", &charsize);
    if (fplconfg != NULL) fclose(fplconfg);
    fplconfg = fopen("plconfig.txt", "w");
    fprintf(fplconfg, "%d %d %d %d %d\n",
	  comnr, baud, parity, stopbits, charsize);
    fclose(fplconfg);
  }

  code = (baud == 110 ? 0 :
	  baud == 150 ? 1 :
	  baud == 300 ? 2 :
	  baud == 600 ? 3 :
	  baud == 1200 ? 4 :
	  baud == 2400 ? 5 :
	  baud == 4800 ? 6 :
	  baud == 9600 ? 7 : -1);
  if (code == -1) {printf /* "Baud rate incorrect" */
			("\n   ࠢ쭠"); exit(1);}
  if (parity == 2) parity = 3;
				/* ७   "" ࠢ 3 */
				/* Internal code for 'even' is 3    */
  port = comnr-1;               /* 0  com1, 1  com2 */
				/* 0 for com1, 1 for com2 */
  byte = (code << 5) | (parity << 3) |
	      ((stopbits-1) << 2) | (charsize - 5);
  retval = bioscom(0, byte, port);
	    /* ஢ઠ   ॣ஢ ᤢ । */
	    /*  ࠭ ।  ⮢ ;          */
	    /* Test on: transfer shift register empty,           */
	    /* transfer holding register empty, data ready.      */
  if ((retval & 0x6100) != 0x6100)
  { printf /* "Initialization error;" */
	 ("\n訡 樠樨 : ");
    printf("AH = %02XH\n", retval >> 8);
    exit(1);
  }
  ser_str("IN;PU;");      /* 樠 */      /* Initialize */
  penposition = 0;
}

float scalingfactor(void)
{ float f;
  printf /* "Enter scaling factor f" */
       ("\n 樥 ⠡஢ :\n");
  printf("(f = 1: ॠ쭠  \n");		/* true length */
  printf(" f > 1: 㢥祭     \n");		/* magnify     */
  printf(" f < 1: 㬥襭      ) : ");	/* reduce      */
  scanf("%f", &f);
  getchar();       /*   ப ய᪠ */
		   /* Newline character skipped        */
  return f;
}

void ser_str(char *p)
{ while (*p) ser_char(*(p++));
}

void ser_char(char ch)
{ int retval;
  /* ஢ઠ  ⮢    ⪠ । ।祩
     Test on: Data set ready, Clear to send.
  */
  do
  { retval = bioscom(3, byte, port);
  } while ((retval & 0x0030) != 0x0030);
  bioscom(1, ch, port);
}

char getcapital(void)
{ char ch;
  ch = getche();
  return toupper(ch);
}

