/* TCYL:        ணࠬ D3D  稢 T-ࠧ
	     ꥪ⮢,    ᥪ 樫஢.

	       Preprocessor for D3D, to draw a T-shaped object
	       consisting of two intersecting cylinders.
*/
#include <stdio.h>
#include <math.h>
#include <process.h>
#include <alloc.h>

void wri(int a);
void wr4(int a, int b, int c, int d);
void endcode(void);

FILE *fp;

main()
{ char filnam[30];
  int i, n, n2, n3, n4, n5, n6, n8, n9, n10,
      tablelength;
  float a, b, l, L, D, d, R, r, alpha, theta, delta,
      *x, *y, *z, pi, beta;
  pi = 4.0 * atan(1.0);

  printf("\n\n\n 奬 -ࠧ ᮥ \n");
  printf(                /*  length L, diameter D */
	"\n ________________________  \n");
  printf( "(________________________)   L,  D\n");
  printf( "           ||\n");
  printf( "           ||\n");
  printf( "           ||    l,  d\n");
  printf( "           ||\n");              /* length l, diameter d */
  printf( "           ||\n");

  do
  { printf("                  ( d < D,  d < L )\n\n\n");
    printf /* "Enter d, D, l, L in that order:" */
	(" 祭 d, D, l, L   ⮬ 浪\n");
    scanf("%f %f %f %f", &d, &D, &l, &L);
  } while (d >= D || d >= L);
  R = D/2; r = d/2; a = l + R; b = L/2;

  printf  /* "The circular boundary face with diameter d will be
      approximated by a regular polygon of 2n sides. Enter n:" */
     ("\n㣮 ࠭筠 ࠭  ஬ d 㤥 ப"
      "஢\nࠢ 㣮쭨  ᫮ ஭ 2n."
      "\n\n 祭 n : "); scanf("%d", &n);

  printf /* "Name of output file: " */
       ("\n 室 䠩 : "); scanf("%s", filnam);
  fp = fopen(filnam, "w");
  if (fp == NULL) {printf  /* "File problem" */
		       ("\n  䠩\n"); exit(1);}
  n2 = 2*n; n3 = 3*n; n4 = 4*n; n5 = 5*n;
  n6 = 6*n; n8 = 8*n; n9 = 9*n; n10 = 10*n;
  tablelength = (n10 + 1) * sizeof(float);
  x = (float *)malloc(tablelength);
  y = (float *)malloc(tablelength);
  z = (float *)malloc(tablelength);
  if (z == NULL) {printf /* "Not enough memory" */
		      ("\n 墠⠥ "); exit(1);}
  theta = pi/n;
  for (i=1; i<=n2; i++)
  { x[i] = a;
    y[i] = r*sin((i-1)*theta);
    z[i] = r*cos((i-1)*theta);
  }
  for (i=n2+1; i<=n4; i++)
  { y[i] = y[i-n2]; z[i] = z[i-n2];
    x[i] = sqrt(R*R - z[i]*z[i]);
  }
  for (i=n4+1; i<=n5; i++)
  { x[i] = x[i-n2]; y[i] = b; z[i] = z[i-n2];
  }
  for (i=n5+1; i<=n6; i++)
  { x[i] = x[i-n]; y[i] = -b; z[i] = z[i-n];
  }
  alpha = atan(z[n4+1]/x[n4+1]);
  delta = (pi - alpha)/n;
  for (i=n6+1; i<=n8; i++)
  { beta = alpha + (i-n6-1)*delta;
    x[i] = R * cos(beta); y[i] = b; z[i] = -R * sin(beta);
  }
  for (i=n8+1; i<=n10; i++)
  { x[i] = x[i-n2]; y[i] = -b; z[i] = z[i-n2];
  }
  for (i=1; i<=n10; i++)
    fprintf(fp, "%d %f %f %f\n", i, x[i], y[i], z[i]);

  fprintf(fp, "\nFaces = ࠭ :\n");

		/* 訩 樫,  ਢ 孮 */
		/* Smaller cylinder, curved surface:           */
  for (i=1; i<n2; i++) wr4(i, i+1, i+n2+1, i+n2);
  wr4(n2, 1, n2+1, n4);

       /* 訩 樫,  ਢ 孮 ࠢ   */
       /* 襣 樫,  ࠢ ᢥ :        */
       /* Larger cylinder, pieces on curved surface to the     */
       /* right of smaller cylinder; from top to bottom:       */
  for (i=n2+1; i<n3; i++) wr4(i, i+1, i+n2+1, i+n2);
  wr4(n3, n3+1, n6+1, n5);

	 /* 訩 樫,  ਢ 孮 ᫥  */
	 /* 襣 樫,  ࠢ ᭨ :      */
	 /* Larger cylinder, pieces on curved surface to the   */
	 /* left of smaller cylinder; from bottom to top:      */
  wr4(n3+2, n6, n8+1, n3+1);
  for (i=n3+3; i<=n4; i++) wr4(i, n9+2-i, n9+3-i, i-1);
  wr4(n2+1, n5+1, n5+2, n4);

   /* 让 樫, אַ㣮 ᪨ ਢ 孮, */
   /* 稭騥  襩 窨  樫:        */
   /* Larger cylinder, large rectangular pieces on curved      */
   /* surface, starting near the smaller cylinder's lowest     */
   /* point:                                                   */
  wri(n6+2); wr4(n6+1, n3+1, n8+1, n8+2);
  for (i=n6+3; i<=n8; i++) wr4(i, i-1, i+n2-1, i+n2);
  wri(n4+1); wr4(n8, n10, n5+1, n2+1);

	      /* ᪠ । 孮  樫  */
	      /* Flat front surface of smaller cylinder:       */
  for (i=n2; i>0; i--) wri(i);
  endcode();

	      /* ࠢ ᪠ 孮 讣 樫  */
	      /* Right-hand flat surface of larger cylinder.   */
  for (i=n4+1; i<=n5; i++) wri(i);        /* ।     */
					  /* Front portion     */
  for (i=n6+1; i<=n8; i++) wri(i);        /* ⠫쭠    */
					  /* Remaining portion */
  endcode();

		/*  ᪠ 孮 讣 樫 */
		/* Left-hand flat surface of larger cylinder.  */
  for (i=n6; i>n5; i--) wri(i);           /* ।     */
					  /* Front portion     */
  for (i=n10; i>n8; i--) wri(i);          /* ⠫쭠    */
					  /* Remaining portion */
  endcode();
  fclose(fp);
}

void wri(int a)
{ fprintf(fp, " %d", a);
}

void wr4(int a, int b, int c, int d)
{ fprintf(fp, " %d %d %d %d.\n", a, b, c, d);
}

void endcode(void)
{ fprintf(fp,".\n");
}